//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Display.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include		<avr/io.h>
#include		<avr/eeprom.h>
#include		<avr/pgmspace.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"Serial.h"
#include		"Utility.h"
#include		"Setting.h"
#include		"LCD.h"
#include		"Timer.h"
#include		"Graph.h"
#include		"EEPROM.h"
#include		"Rtc.h"
#include		"Comm1.h"

#include		"Display.h"

static unsigned long	grh_work_buf[64];

//*****************************************
// uU[̂nm^nee\
//*****************************************
void	disp_buz_symble(void)
{
	disp_moji[0]=' ';
	disp_moji[1]=' ';
	disp_moji[2]=0x00;
	if(buz_on == 1){
		disp_moji[0]=0x01;
		disp_moji[1]=0x02;
	}
	disp_lcd_G( 18,7,disp_moji);									// \

}
//*****************************************
// 炕r^ɊZ
//*****************************************
unsigned long	cpm_to_uSv_h(unsigned long cpm)
{
	unsigned long ul;

	if(cpm <= (unsigned long)cpm_to_uSv_ofs){				// lJEgl
		ul = (unsigned long)0;
	}else{
		cpm -= (unsigned long)cpm_to_uSv_ofs;				// JEgl
		ul = ((cpm * (unsigned long)1000) / (unsigned long)cpm_to_uSv_spn);	// 0.01PʂuSv

		if((unsigned long)999999 < ul){
			ul = (unsigned long)999999;
		}
	}

	return(ul);
}

//*****************************************
// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
//*****************************************
static	unsigned char	get_befor_num_cpm(void)
{
	unsigned char	num;

	num = cpm_data_pos;										// xۑf[^̈Oɂ
	num--;
	num &= (N_of_MINUTE_DATA - 1);

	return(num);
}
//*****************************************
// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
//*****************************************
unsigned char	get_next_num_cpm(void)
{
	unsigned char	num;

	num = cpm_data_pos;										// xۑf[^̈ɂ
	num++;
	num &= (N_of_MINUTE_DATA - 1);

	return(num);
}
//*****************************************
// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
//*****************************************
unsigned char	get_befor_num_cph(void)
{
	unsigned char	num;

	num = cph_data_pos;										// xۑf[^̈Oɂ
	num--;
	num &= (N_of_HOUR_DATA - 1);

	return(num);
}
//*****************************************
// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
//*****************************************
unsigned char	get_next_num_cph(void)
{
	unsigned char	num;

	num = cph_data_pos;										// xۑf[^̈ɂ
	num++;
	num &= (N_of_HOUR_DATA - 1);

	return(num);
}
//*****************************************
// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
//*****************************************
unsigned char	get_befor_num_cpd(void)
{
	unsigned char	num;

	num = cpd_data_pos;										// xۑf[^̈Oɂ
	num--;
	num &= (N_of_DAY_DATA - 1);

	return(num);
}
//*****************************************
// ̍ۑĂ鏊̂ЂƂ̔ԍ߂
//*****************************************
unsigned char	get_next_num_cpd(void)
{
	unsigned char	num;

	num = cpd_data_pos;										// xۑf[^̈ɂ
	num++;
	num &= (N_of_DAY_DATA - 1);

	return(num);
}
//*****************************************
// rZϕ\p擾iZWɂĂPOAPWARSAUQԂ̃JEgɂj
//   disp_moji[] ɓ
// 0123456789012345
// Ave.  1.23uSv/h
//*****************************************
static	void	get_average_moji(void)
{
	unsigned long	ul;
	unsigned char	i;
	unsigned char	n;
	unsigned char	num;
	unsigned int	ui;
	unsigned int	maxd=0;
	unsigned int	mind=0xffff;
	unsigned long	s=0;
	unsigned char	yuukou=0;
	char			mm[21];

	if(3000 <= cpm_to_uSv_spn){								// ZWiXpj300.0 ȏ
		n = 10;												// ރf[^ij
	}else if(900 <= cpm_to_uSv_spn){						// ZWiXpj90.0 ȏ
		n = 18;												// ރf[^ij
	}else if(300 <= cpm_to_uSv_spn){						// ZWiXpj30.0 ȏ
		n = 34;												// ރf[^ij
	}else{
		n = 62;
	}

	num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂

	for(i=0;i<n;i++){
		ui = count_minute[num];								// PƂ̃f[^
		if(ui == 0xffff){									// ̃f[^̎
			;
		}else{												// f[^LȎ
			s += (unsigned long)ui;							// 
			if(maxd < ui){									// ől
				maxd = ui;
			}
			if(ui < mind){									// ŏl
				mind = ui;
			}
			yuukou++;
		}
		num--;												// Oɂ
		num &= 0x3f;
	}

	if(yuukou == 0){										// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		llstrcpy(mm,(char *)(&disp_moji[0]));
		llstrcpy((char *)(disp_moji), mm);
	}else{
		if(yuukou < 4){										// Lȃf[^S̎
			s /= (unsigned long)yuukou;						// Pȕϒl
		}else{
			s -= (unsigned long)maxd;						// ԑ傫Ȓl
			s -= (unsigned long)mind;						// ԏȒl
			s /= (unsigned long)(yuukou - 2);				// Lf[^|Qŕϒlo
		}

		ul = cpm_to_uSv_h(s);								// 炕r^ɊZ

		if(yuukou < n){										// ȃf[^L
			get_pgm_str(&str_5asta[0]);						// vÖ̕("*****")擾
			llstrcpy(mm,(char *)(&disp_moji[4]));
			llstrcpy((char *)(disp_moji), mm);
		}else{
			get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
			llstrcpy(mm,(char *)(&disp_moji[9]));
			llstrcpy((char *)(disp_moji), mm);
		}

		if(ul <= 999){										// 9.99 ȉ(00999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[6] = disp_moji[5];
			disp_moji[5] = disp_moji[4];
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			llstrcpy(&mm[1],(char *)(&disp_moji[2]));
			llstrcpy((char *)(disp_moji), mm);
		}else if(ul <= 9999){								// 99.9 ȉ(09999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			if(disp_moji[1] == '0'){
				disp_moji[1] = ' ';
			}
			llstrcpy(&mm[1],(char *)(&disp_moji[1]));
			llstrcpy((char *)(disp_moji), mm);
		}else{												// (999999)
			wtod_5u((char *)disp_moji,(unsigned int)(ul / (unsigned int)100));	// _ŕɂ
			llstrcpy(&mm[1],(char *)(&disp_moji[1]));
			llstrcpy((char *)(disp_moji), mm);
		}
	}
}
//*****************************************
// rZϕ\iZWɂĂPOAPWARSԂ̃JEgɂj
//  F\ʒu(0-->15)
//  Fs\ʒu(0-->1)
//
// 0123456789012345
// Ave.  1.23uSv/h
//*****************************************
static	void	disp_average(unsigned char x, unsigned char y)
{
	unsigned long	ul;
	unsigned char	i;
	unsigned char	n;
	unsigned char	num;
	unsigned int	ui;
	unsigned int	maxd=0;
	unsigned int	mind=0xffff;
	unsigned long	s=0;
	unsigned char	yuukou=0;

	if(3000 <= cpm_to_uSv_spn){								// ZWiXpj300.0 ȏ
		n = 10;												// ރf[^ij
	}else if(900 <= cpm_to_uSv_spn){						// ZWiXpj90.0 ȏ
		n = 18;												// ރf[^ij
	}else if(300 <= cpm_to_uSv_spn){						// ZWiXpj30.0 ȏ
		n = 34;												// ރf[^ij
	}else{
		n = 0;
	}

	num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂

	for(i=0;i<n;i++){
		ui = count_minute[num];								// PƂ̃f[^
		if(ui == 0xffff){									// ̃f[^̎
			;
		}else{												// f[^LȎ
			s += (unsigned long)ui;							// 
			if(maxd < ui){									// ől
				maxd = ui;
			}
			if(ui < mind){									// ŏl
				mind = ui;
			}
			yuukou++;
		}
		num--;												// Oɂ
		num &= 0x3f;
	}

	if(yuukou == 0){										// f[^
		get_pgm_str(&str_5minus[0]);						// vÖ̕("----")擾
		disp_lcd_G(x+1,y,&disp_moji[1]);					// \
	}else{
		if(yuukou < 4){										// Lȃf[^S̎
			s /= (unsigned long)yuukou;						// Pȕϒl
		}else{
			s -= (unsigned long)maxd;						// ԑ傫Ȓl
			s -= (unsigned long)mind;						// ԏȒl
			s /= (unsigned long)(yuukou - 2);				// Lf[^|Qŕϒlo
		}

		ul = cpm_to_uSv_h(s);								// 炕r^ɊZ

		if(yuukou < n){										// ȃf[^L
			get_pgm_str(&str_5asta[0]);						// vÖ̕("*****")擾
			disp_lcd_G(x,y,&disp_moji[4]);					// \
		}else{
			get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
			disp_lcd_G(x,y,&disp_moji[9]);					// \
		}

		if(ul <= 999){										// 9.99 ȉ(00999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[6] = disp_moji[5];
			disp_moji[5] = disp_moji[4];
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			disp_lcd_G(x+1, y, &disp_moji[2]);				// display Dot Matrix LCD Up or Down Side
		}else if(ul <= 9999){								// 99.9 ȉ(09999)
			wtod_05u((char *)disp_moji,(unsigned int)ul);	// ɂ
			disp_moji[4] = disp_moji[3];
			disp_moji[3] = '.';
			if(disp_moji[1] == '0'){
				disp_moji[1] = ' ';
			}
			disp_lcd_G(x+1, y, &disp_moji[1]);				// display Dot Matrix LCD Up or Down Side
		}else{												// (999999)
			wtod_5u((char *)disp_moji,(unsigned int)(ul / (unsigned int)100));	// _ŕɂ
			disp_lcd_G(x+1, y, &disp_moji[1]);				// display Dot Matrix LCD Up or Down Side
		}
	}
}
//*****************************************
// ÔPԖ̒l@\
//*****************************************
static	void	disp_befor_cpm(unsigned char x, unsigned char y)
{
	unsigned char	num;

	num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂

	if(count_minute[num] == 0xffff){						// ÔPԖ̃f[^
		get_pgm_str(&str_space10[0]);						// vÖ̕("      ")擾
		disp_lcd_G(x,y,&disp_moji[6]);						// \
	}else{
		wtod_5u((char *)disp_moji,count_minute[num]);		// ÔPԖ̒l
		disp_lcd_G(x, y, &disp_moji[0]);					// display Dot Matrix LCD Up or Down Side
	}
}
//*****************************************
// ̂PԖ̒l@\iőVj
//   x:\ŏʌ̂WiO`PXj
//  @@ y:\yWiO`Vj
//*****************************************
static	void	disp_now_cph(unsigned char x, unsigned char y)
{
	unsigned long	ul;

	ul = count_hour[cph_data_pos];				// ̍ۑĂl

	if(ul == 0xffffffff){						// ̂PԖ̃f[^
		get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
		disp_lcd_G(x,y,&disp_moji[3]);			// \
	}else{
		wtod_7u((char *)disp_moji, ul);			// ̂PԖ̏S̒l
		disp_lcd_G(x, y, &disp_moji[0]);		// display Dot Matrix LCD
	}
}
//*****************************************
// ̂P̒l@\iőVj
//   x:\ŏʌ̂WiO`PXj
//  @@ y:\yWiO`Vj
//*****************************************
static	void	disp_now_cpd(unsigned char x, unsigned char y)
{
	unsigned long	ul;

	ul = count_day[cpd_data_pos];				// ̍ۑĂl

	if(ul == 0xffffffff){						// ̂P̃f[^
		get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
		disp_lcd_G(x,y,&disp_moji[3]);			// \
	}else{
		wtod_7u((char *)disp_moji, ul);			// ̂PƂ̒l
		disp_lcd_G(x, y, &disp_moji[0]);		// display Dot Matrix LCD
	}
}
//*****************************************
// 荀ڂ̕\ij
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_meas_data_full(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static	unsigned char	befor_sec = 0xff;
	static	unsigned int	befor_now = 0xffff;
	static	unsigned int	befor_cpm = 0xffff;
	static	unsigned long	befor_cph = 0xffffffff;
	static	unsigned long	befor_cpd = 0xffffffff;
	static	unsigned int	befor_hv  = 0xffff;
	static	unsigned int	befor_hv_out  = 0xffff;
	static	unsigned int	befor_bat  = 0xffff;
	unsigned char			num;
	unsigned long			ul;

	if((*disp_item & DISP_MEAS_SEC_00)!=0){						// display Sec
		*disp_item &= ~DISP_MEAS_SEC_00;
		if((befor_sec != tim_1s_a)||(disp_any_condition != 0)){
			befor_sec = tim_1s_a;
			wtod_02u((char *)(disp_moji), 60 - befor_sec);
			disp_lcd_G(18, 0, &disp_moji[0]);					// display Dot Matrix LCD Line-No.0
		}
	}
	if((*disp_item & DISP_MEAS_NOW_01)!=0){						// display Now cpm(Minute)
		*disp_item &= ~DISP_MEAS_NOW_01;
		num = cpm_data_pos;										// ̍ۑĂ鏊̔ԍ߂
		if((befor_now != count_minute[num])||(disp_any_condition != 0)){
			befor_now = count_minute[num];
			wtod_5u((char *)disp_moji,count_minute[num]);		// PԖ̒l
			disp_lcd_G( 5, 0, &disp_moji[0]);					// display Dot Matrix LCD
		}
	}
	if((*disp_item & DISP_MEAS_CPM_02)!=0){						// display cpm(Minute)
		*disp_item &= ~DISP_MEAS_CPM_02;
		num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
		if((befor_cpm != count_minute[num])||(disp_any_condition != 0)){
			befor_cpm = count_minute[num];
			disp_befor_cpm( 5,  1);								// ÔPԖ̒l
			disp_uSv_at_count(11, 1, count_minute[num], 1, 0);	// rZ\iPԂ̃JEgɂj
			disp_average(10,  2);								// ϒl
		}
	}
	if((*disp_item & DISP_MEAS_CPH_03)!=0){						// display cph(Hour)
		*disp_item &= ~DISP_MEAS_CPH_03;
		num = cph_data_pos;										// ̍ۑĂ鏊̔ԍ
		if((befor_cph != count_hour[num])||(disp_any_condition != 0)){
			befor_cph = count_hour[num];
			disp_now_cph( 3, 3);								// ̂PԖ̒l@\
			if((befor_cph == 0xffffffff)||(tim_1minute == 60)){
				ul = befor_cph;
			}else{
				ul = (befor_cph * 60L)/(unsigned long)(60 - tim_1minute);
			}
			disp_uSv_at_count(11, 3, ul, 0, 0);					// rZ\iPԂ̃JEgɂj
		}
		wtod_02u((char *)(disp_moji), 60 - tim_1minute);
		disp_lcd_G(15, 0, &disp_moji[0]);						// display Dot Matrix LCD Line-No.0
	}
	if((*disp_item & DISP_MEAS_CPD_04)!=0){						// display cpd(Day)
		*disp_item &= ~DISP_MEAS_CPD_04;
		num = cpd_data_pos;										// ̍ۑĂ鏊̔ԍ
		if((befor_cpd != count_day[num])||(disp_any_condition != 0)){
			befor_cpd = count_day[num];
			disp_now_cpd( 3, 4);								// ̂P̒l@\
			if((befor_cpd == 0xffffffff)||(tim_1hour == 24)){
				ul = befor_cpd;
			}else{
				ul = befor_cpd/(unsigned long)(24 - tim_1hour);
			}
			disp_uSv_at_count(11, 4, ul, 0, 0);					// rZ\iP̃JEgɂj
		}
		wtod_02u((char *)(disp_moji), 24 - tim_1hour);
		disp_lcd_G(12, 0, &disp_moji[0]);						// display Dot Matrix LCD Line-No.0
	}
	if((*disp_item & DISP_MEAS_HV_05)!=0){						// display High Volt
		*disp_item &= ~DISP_MEAS_HV_05;
		get_hv_moni();											// guj^l(Volt)̎擾(hv_moni ɓ)
		if((befor_hv != hv_moni)||(disp_any_condition != 0)){
			befor_hv = hv_moni;
			wtod_5u((char *)disp_moji,hv_moni);					// High Volt Data
			disp_lcd_G( 8, 6, &disp_moji[2]);					// display Dot Matrix LCD Up or Down Side
		}
		if((befor_hv_out != hv_out)||(disp_any_condition != 0)){
			befor_hv_out = hv_out;
			wtod_5u((char *)disp_moji,hv_out);					// High Out Data
			disp_lcd_G(17, 6, &disp_moji[2]);					// display Dot Matrix LCD Up or Down Side
		}
	}
	if((*disp_item & DISP_MEAS_BAT_06)!=0){						// display Battery
		*disp_item &= ~DISP_MEAS_BAT_06;
		get_bat_moni();											// obej^l(Volt)̎擾(bat_moni ɓ)
		if((befor_bat != bat_moni)||(disp_any_condition != 0)){
			befor_bat = bat_moni;
			wtod_5u((char *)disp_moji,bat_moni);				// battry Volt Data
			disp_moji[1] = disp_moji[2];
			disp_moji[2] = '.';
			disp_lcd_G( 4, 7, &disp_moji[1]);					// display Dot Matrix LCD Up or Down Side
		}
	}
}

//*****************************************
// 荀ڂ̕\iJEgj
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_meas_data_count(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static	unsigned char	befor_sec = 0xff;
	static	unsigned int	befor_now = 0xffff;
	static	unsigned int	befor_cpm = 0xffff;
	static	unsigned long	befor_cph = 0xffffffff;
	static	unsigned long	befor_cpd = 0xffffffff;
	static	unsigned int	befor_hv  = 0xffff;
	static	unsigned int	befor_bat  = 0xffff;
	unsigned char			num;

	if((*disp_item & DISP_MEAS_SEC_00)!=0){						// display Sec
		*disp_item &= ~DISP_MEAS_SEC_00;
		if((befor_sec != tim_1s_a)||(disp_any_condition != 0)){
			befor_sec = tim_1s_a;
			wtod_02u((char *)(disp_moji), 60 - befor_sec);
			disp_lcd_G(18, 0, &disp_moji[0]);					// display Dot Matrix LCD Line-No.0
		}
	}
	if((*disp_item & DISP_MEAS_NOW_01)!=0){						// display Now cpm(Minute)
		*disp_item &= ~DISP_MEAS_NOW_01;
		num = cpm_data_pos;										// ̍ۑĂ鏊̔ԍ߂
		if((befor_now != count_minute[num])||(disp_any_condition != 0)){
			befor_now = count_minute[num];
			wtod_5u((char *)disp_moji,count_minute[num]);		// PԖ̒l
			disp_lcd_G(11, 1, &disp_moji[0]);					// display Dot Matrix LCD
		}
	}
	if((*disp_item & DISP_MEAS_CPM_02)!=0){						// display cpm(Minute)
		*disp_item &= ~DISP_MEAS_CPM_02;
		num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
		if((befor_cpm != count_minute[num])||(disp_any_condition != 0)){
			befor_cpm = count_minute[num];
			disp_befor_cpm(11,  2);								// ÔPԖ̒l
		}
	}
	if((*disp_item & DISP_MEAS_CPH_03)!=0){						// display cph(Hour)
		*disp_item &= ~DISP_MEAS_CPH_03;
		num = cph_data_pos;										// ̍ۑĂ鏊̔ԍ
		if((befor_cph != count_hour[num])||(disp_any_condition != 0)){
			befor_cph = count_hour[num];
			disp_now_cph( 9, 3);								// ̂PԖ̒l@\
		}
	}
	if((*disp_item & DISP_MEAS_CPD_04)!=0){						// display cpd(Day)
		*disp_item &= ~DISP_MEAS_CPD_04;
		num = cpd_data_pos;										// ̍ۑĂ鏊̔ԍ
		if((befor_cpd != count_day[num])||(disp_any_condition != 0)){
			befor_cpd = count_day[num];
			disp_now_cpd( 9, 4);								// ̂P̒l@\
		}
	}
	if((*disp_item & DISP_MEAS_HV_05)!=0){						// display High Volt
		*disp_item &= ~DISP_MEAS_HV_05;
		get_hv_moni();											// guj^l(Volt)̎擾(hv_moni ɓ)
		if((befor_hv != hv_moni)||(disp_any_condition != 0)){
			befor_hv = hv_moni;
			wtod_5u((char *)disp_moji,hv_moni);					// High Volt Data
			disp_lcd_G( 9, 6, &disp_moji[2]);					// display Dot Matrix LCD Up or Down Side
		}
	}
	if((*disp_item & DISP_MEAS_BAT_06)!=0){						// display Battery
		*disp_item &= ~DISP_MEAS_BAT_06;
		get_bat_moni();											// obej^l(Volt)̎擾(bat_moni ɓ)
		if((befor_bat != bat_moni)||(disp_any_condition != 0)){
			befor_bat = bat_moni;
			wtod_5u((char *)disp_moji,bat_moni);				// battry Volt Data
			disp_moji[1] = disp_moji[2];
			disp_moji[2] = '.';
			disp_lcd_G( 4, 7, &disp_moji[1]);					// display Dot Matrix LCD Up or Down Side
		}
	}
}

//*****************************************
// 荀ڂ̕\iu^j
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_meas_data_usv_h(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static	unsigned char	befor_sec = 0xff;
	static	unsigned int	befor_now = 0xffff;
	static	unsigned int	befor_cpm = 0xffff;
	static	unsigned long	befor_cph = 0xffffffff;
	static	unsigned long	befor_cpd = 0xffffffff;
	static	unsigned int	befor_hv  = 0xffff;
	static	unsigned int	befor_bat  = 0xffff;
	unsigned char			num;
	unsigned long			ul;

	if((*disp_item & DISP_MEAS_SEC_00)!=0){						// display Sec
		*disp_item &= ~DISP_MEAS_SEC_00;
		if((befor_sec != tim_1s_a)||(disp_any_condition != 0)){
			befor_sec = tim_1s_a;
			wtod_02u((char *)(disp_moji), 60 - befor_sec);
			disp_lcd_G(18, 0, &disp_moji[0]);					// display Dot Matrix LCD Line-No.0
		}
	}
	if((*disp_item & DISP_MEAS_NOW_01)!=0){						// display Now cpm(Minute)
		*disp_item &= ~DISP_MEAS_NOW_01;
		num = cpm_data_pos;										// ̍ۑĂ鏊̔ԍ߂
		befor_now = count_minute[num];
		ul = befor_now;
		ul *= 60;
		ul /= (60 - tim_1s_a);
		get_uSv_at_count(ul, 1);								// rZ
		disp_lcd_G(10, 1, &disp_moji[0]);						// display Dot Matrix LCD
	}
	if((*disp_item & DISP_MEAS_CPM_02)!=0){						// display cpm(Minute)
		*disp_item &= ~DISP_MEAS_CPM_02;
		num = get_befor_num_cpm();								// ̍ۑĂ鏊̂ЂƂO̔ԍ߂
		if((befor_cpm != count_minute[num])||(disp_any_condition != 0)){
			befor_cpm = count_minute[num];
			ul = befor_cpm;
			get_uSv_at_count(ul, 1);							// rZ
			disp_lcd_G(10, 2, &disp_moji[0]);					// display Dot Matrix LCD
		}
		get_average_moji();										// rZ
		disp_lcd_G( 9, 3, &disp_moji[0]);						// display Dot Matrix LCD
	}
	if((*disp_item & DISP_MEAS_CPH_03)!=0){						// display cph(Hour)
		*disp_item &= ~DISP_MEAS_CPH_03;
		num = get_befor_num_cph();								// ̍ۑĂ鏊̈O̔ԍ
		if((befor_cph != count_hour[num])||(disp_any_condition != 0)){
			befor_cph = count_hour[num];
			get_uSv_at_count(befor_cph, 0);							// rZ
			disp_lcd_G(10, 4, &disp_moji[0]);					// display Dot Matrix LCD
		}
	}
	if((*disp_item & DISP_MEAS_CPD_04)!=0){						// display cpd(Day)
		*disp_item &= ~DISP_MEAS_CPD_04;
		num = get_befor_num_cpd();								// ̍ۑĂ鏊̈O̔ԍ
		if((befor_cpd != count_day[num])||(disp_any_condition != 0)){
			befor_cpd = count_day[num];
			if(befor_cpd == 0xffffffff){
				ul = befor_cpd;
			}else{
				ul = count_day[num]/(unsigned long)24;
			}
			get_uSv_at_count(ul, 0);							// rZ
			disp_lcd_G(10, 5, &disp_moji[0]);					// display Dot Matrix LCD
		}
	}
	if((*disp_item & DISP_MEAS_HV_05)!=0){						// display High Volt
		*disp_item &= ~DISP_MEAS_HV_05;
		get_hv_moni();											// guj^l(Volt)̎擾(hv_moni ɓ)
		if((befor_hv != hv_moni)||(disp_any_condition != 0)){
			befor_hv = hv_moni;
			wtod_5u((char *)disp_moji,hv_moni);					// High Volt Data
			disp_lcd_G( 9, 6, &disp_moji[2]);					// display Dot Matrix LCD Up or Down Side
		}
	}
	if((*disp_item & DISP_MEAS_BAT_06)!=0){						// display Battery
		*disp_item &= ~DISP_MEAS_BAT_06;
		get_bat_moni();											// obej^l(Volt)̎擾(bat_moni ɓ)
		if((befor_bat != bat_moni)||(disp_any_condition != 0)){
			befor_bat = bat_moni;
			wtod_5u((char *)disp_moji,bat_moni);				// battry Volt Data
			disp_moji[1] = disp_moji[2];
			disp_moji[2] = '.';
			disp_lcd_G( 4, 7, &disp_moji[1]);					// display Dot Matrix LCD Up or Down Side
		}
	}
}
//*****************************************
// 荀ڂ̕\iȂj
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_meas_data(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static	unsigned char	befor_sec = 0xff;
	static	unsigned int	befor_now = 0xffff;
	static	unsigned int	befor_bat  = 0xffff;
	unsigned char			num;
	unsigned long			ul;

	if((*disp_item & DISP_MEAS_SEC_00)!=0){						// display Sec
		*disp_item &= ~DISP_MEAS_SEC_00;
		if((befor_sec != tim_1s_a)||(disp_any_condition != 0)){
			befor_sec = tim_1s_a;
			wtod_02u((char *)(disp_moji), 60 - befor_sec);
			disp_lcd_G(18, 6, &disp_moji[0]);					// display Dot Matrix LCD Line-No.0
		}
	}

	if((*disp_item & DISP_MEAS_NOW_01)!=0){						// display Now cpm(Minute)
		*disp_item &= ~DISP_MEAS_NOW_01;
		num = cpm_data_pos;										// ̍ۑĂ鏊̔ԍ߂
		if((befor_now != count_minute[num])||(disp_any_condition != 0)){
			befor_now = count_minute[num];
			wtod_5u((char *)disp_moji,count_minute[num]);		// PԖ̒l
			disp_lcd_10x16_G( 2, 0, &disp_moji[0]);				// display Dot Matrix LCD 10x16 Line-No.0
		}
		ul = count_minute[num];
		ul *= 60;
		ul /= (60 - tim_1s_a);
		get_uSv_at_count(ul, 1);								// rZ
		disp_lcd_10x16_G( 3, 1, &disp_moji[0]);					// display Dot Matrix LCD 10x16 Line-No.0
	}

	if((*disp_item & DISP_MEAS_CPM_02)!=0){						// display cpm(Minute)
		*disp_item &= ~DISP_MEAS_CPM_02;
		get_average_moji();
		if(disp_moji[0] == '*'){
			disp_moji[0] = 0x01;
		}
		disp_lcd_10x16_G( 2, 2, &disp_moji[0]);					// display Dot Matrix LCD 10x16 Line-No.0
	}

	if((*disp_item & DISP_MEAS_CPH_03)!=0){						// display cph(Hour)
		*disp_item &= ~DISP_MEAS_CPH_03;
		wtod_02u((char *)(disp_moji), 60 - tim_1minute);
		disp_lcd_G(15, 6, &disp_moji[0]);						// display Dot Matrix LCD Line-No.0
	}

	if((*disp_item & DISP_MEAS_CPD_04)!=0){						// display cpd(Day)
		*disp_item &= ~DISP_MEAS_CPD_04;
		wtod_02u((char *)(disp_moji), 24 - tim_1hour);
		disp_lcd_G(12, 6, &disp_moji[0]);						// display Dot Matrix LCD Line-No.0
	}

	if((*disp_item & DISP_MEAS_BAT_06)!=0){						// display Battery
		*disp_item &= ~DISP_MEAS_BAT_06;
		get_bat_moni();											// obej^l(Volt)̎擾(bat_moni ɓ)
		if((befor_bat != bat_moni)||(disp_any_condition != 0)){
			befor_bat = bat_moni;
			wtod_5u((char *)disp_moji,bat_moni);				// battry Volt Data
			disp_moji[1] = disp_moji[2];
			disp_moji[2] = '.';
			disp_lcd_G( 4, 7, &disp_moji[1]);					// display Dot Matrix LCD Up or Down Side
		}
	}

	*disp_item = 0;
}
//*****************************************
// US̍ől߂
//   cph: 0=cpm, 1=cph, 2=cpd, 3= grh_work_buf[64]
//*****************************************
unsigned long	get_max_value(unsigned char	cph)
{
	unsigned char	i;
	unsigned long	max = 0;
	unsigned char	loop_max;

	if(cph == 0){												//  ̎
		loop_max = N_of_MINUTE_DATA;
		for(i=0;i<loop_max;i++){
			if(count_minute[i] == 0xffff){						// f[^
				;												// fȂ
			}else{												// f[^L鎞
				if(max < (unsigned long)(count_minute[i])) {
					max  = (unsigned long)(count_minute[i]);
				}
			}
		}
	}else if(cph == 1){											// ̎
		loop_max = N_of_HOUR_DATA;
		for(i=0;i<loop_max;i++){
			if(count_hour[i] == 0xffffffff){					// f[^
				;												// fȂ
			}else{												// f[^L鎞
				if(max < (unsigned long)(count_hour[i])) {
					max  = (unsigned long)(count_hour[i]);
				}
			}
		}
	}else if(cph == 2){											// ̎
		loop_max = N_of_DAY_DATA;
		for(i=0;i<loop_max;i++){
			if(count_day[i] == 0xffffffff){						// f[^
				;												// fȂ
			}else{												// f[^L鎞
				if(max < (unsigned long)(count_day[i])) {
					max  = (unsigned long)(count_day[i]);
				}
			}
		}
	}else{														// grh_work_buf[64] ̎
		loop_max = 64;
		for(i=0;i<loop_max;i++){
			if(grh_work_buf[i] == 0xffffffff){					// f[^
				;												// fȂ
			}else{												// f[^L鎞
				if(max < (unsigned long)(grh_work_buf[i])) {
					max  = (unsigned long)(grh_work_buf[i]);
				}
			}
		}
	}

	return(max);
}

//*****************************************
// Ot̃Wiőlj߂
//   max: Ot\̍ől
//  @@@ől@傫ĂWO炢ɂȂ郌W߂
//*****************************************
unsigned long	get_range(unsigned long max)
{
	static unsigned long	range_data[17] = 
			{                50L,    100L,    200L,    500L,    1000L,    2000L,    5000L,
			 10000L, 20000L, 50000L, 100000L, 200000L, 500000L, 1000000L, 2000000L, 5000000L,
			 0xffffff,};
	unsigned char	i;
	unsigned long	ul;

	ul = range_data[0];
	for(i=0;i<17;i++){
		if(range_data[i] == 0xffffffff){					// Ō܂ŗ
			break;
		}else{
			ul = range_data[i];
			if(max <= ((ul * 8L)/10L)){
				break;
			}
		}
	}

	return(ul);
}

//*****************************************
// Otf[^ɂăZbg
//   cph: 0=cpm, 1=cph, 2=cpd, 3= grh_work_buf[64]
//        rg: Ot̍ől
//       all: 1=SẴf[^ZbgA 0=߂̃f[^̂݃Zbg
//@@@@@@SĂ̎UOŌÂS̓ZbgȂ
//*****************************************
void	set_graph_data(unsigned char cph, unsigned long rg, unsigned char all)
{
	int				i;
	unsigned char	j;
	unsigned char	uc;
	unsigned long	ul;
	unsigned long	max_dot=50L;					// őlɑΉhbg

	if(all == 1){										// S
		for(i=0;i<N_of_GRAPH_DATA;i++){					// Otf[^@NA
			gGraph_data[i] = 0;
		}

		if(cph == 0){									// ̎
			uc = cpm_data_pos;
			for(i=(N_of_GRAPH_DATA-2),j=0;(0 <= i)&&(j<N_of_MINUTE_DATA);j++,i-=2){
				ul = (unsigned long)count_minute[uc];
				if(ul == 0xffff){						// f[^
					ul = 0;
				}else if(rg < ul){						// WI[o[
					ul = max_dot;
				}else{
					ul = (ul * max_dot)/rg;
				}
				gGraph_data[i+0] = (unsigned char)ul;
				gGraph_data[i+1] = (unsigned char)ul;
				uc--;
				uc &= (N_of_MINUTE_DATA - 1);
			}
		}else if(cph == 1){								// ̎
			uc = cph_data_pos;
			for(i=(N_of_GRAPH_DATA-2),j=0;(0 <= i)&&(j<N_of_HOUR_DATA);j++,i-=2){
				ul = count_hour[uc];
				if(ul == 0xffffffff){					// f[^
					ul = 0;
				}else if(rg < ul){						// WI[o[
					ul = max_dot;
				}else{
					ul = (ul * max_dot)/rg;
				}
				gGraph_data[i+0] = (unsigned char)ul;
				gGraph_data[i+1] = (unsigned char)ul;
				uc--;
				uc &= (N_of_HOUR_DATA - 1);
			}
		}else if(cph == 2){								// ̎
			uc = cpd_data_pos;
			for(i=(N_of_GRAPH_DATA-2),j=0;(0 <= i)&&(j<N_of_DAY_DATA);j++,i-=2){
				ul = count_day[uc];
				if(ul == 0xffffffff){					// f[^
					ul = 0;
				}else if(rg < ul){						// WI[o[
					ul = max_dot;
				}else{
					ul = (ul * max_dot)/rg;
				}
				gGraph_data[i+0] = (unsigned char)ul;
				gGraph_data[i+1] = (unsigned char)ul;
				uc--;
				uc &= (N_of_DAY_DATA - 1);
			}
		}else{											// grh_work_buf[64]̎
			for(i=(N_of_GRAPH_DATA-2),j=0;(0 <= i)&&(j<64);j++,i-=2){
				ul = grh_work_buf[j];
				if(ul == 0xffffffff){					// f[^
					ul = 0;
				}else if(rg < ul){						// WI[o[
					ul = max_dot;
				}else{
					ul = (ul * max_dot)/rg;
				}
				gGraph_data[i+0] = (unsigned char)ul;
				gGraph_data[i+1] = (unsigned char)ul;
			}
		}
		gGraph_data[0] = 0;
		gGraph_data[1] = 0;
		gGraph_data[2] = 0;
		gGraph_data[3] = 0;
	}else{													// ߂̂
		if(cph == 0){									// ̎
			ul = (unsigned long)count_minute[cpm_data_pos];
			if(ul == 0xffff){						// f[^
				ul = 0;
			}else if(rg < ul){						// WI[o[
				ul = max_dot;
			}else{
				ul = (ul * max_dot)/rg;
			}
			gGraph_data[N_of_GRAPH_DATA-2] = (unsigned char)ul;
			gGraph_data[N_of_GRAPH_DATA-1] = (unsigned char)ul;
		}else if(cph == 1){								// ̎
			ul = count_hour[cph_data_pos];
			if(ul == 0xffffffff){					// f[^
				ul = 0;
			}else if(rg < ul){						// WI[o[
				ul = max_dot;
			}else{
				ul = (ul * max_dot)/rg;
			}
			gGraph_data[N_of_GRAPH_DATA-2] = (unsigned char)ul;
			gGraph_data[N_of_GRAPH_DATA-1] = (unsigned char)ul;
		}else if(cph == 2){							// ̎
			ul = count_day[cpd_data_pos];
			if(ul == 0xffffffff){					// f[^
				ul = 0;
			}else if(rg < ul){						// WI[o[
				ul = max_dot;
			}else{
				ul = (ul * max_dot)/rg;
			}
			gGraph_data[N_of_GRAPH_DATA-2] = (unsigned char)ul;
			gGraph_data[N_of_GRAPH_DATA-1] = (unsigned char)ul;
		}else{										// grh_work_buf[64]̎
			ul = grh_work_buf[0];
			if(ul == 0xffffffff){					// f[^
				ul = 0;
			}else if(rg < ul){						// WI[o[
				ul = max_dot;
			}else{
				ul = (ul * max_dot)/rg;
			}
			gGraph_data[N_of_GRAPH_DATA-2] = (unsigned char)ul;
			gGraph_data[N_of_GRAPH_DATA-1] = (unsigned char)ul;
		}
	}
}
//*****************************************
// ̃Ot
//   
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_cpm_graph(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static unsigned long	max_value=0;
	static unsigned long	range=20;

	if((disp_any_condition == 1)||((*disp_item & DISP_MEAS_CPM_02)!=0)){
		disp_clear_lcd_G();													// Clear Display
		max_value = get_max_value(0);										// US̂̍ől߂
		range = get_range(max_value);										// Ot̃Wiőlj߂
		set_graph_data(0,range,1);											// SĂOtf[^ɂăZbg
		display_graph(1,8);
		display_graph_scale();												// Ot̖ڐ\
		get_pgm_str(&str_cpm[0]);											// "cpm"
		disp_lcd_G( 9, 0, &disp_moji[0]);									// display Dot Matrix LCD
		wtod_l7u((char *)disp_moji, range);									// W
		disp_lcd_G(1, 0, &disp_moji[0]);									// display Dot Matrix LCD
		if(count_minute[cpm_data_pos] == 0xffff){							// ̒l
			get_pgm_str(&str_5minus[0]);									// "-----"
			disp_lcd_G(15, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}else{
			wtod_5u((char *)disp_moji, count_minute[cpm_data_pos]);			// ̒l
			disp_lcd_G(15, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}
		disp_buz_symble();													// uU[̂nm^nee\
	}else if((*disp_item & DISP_MEAS_NOW_01)!=0){
		set_graph_data(0,range,0);											// ߂Otf[^ɂăZbg
		display_graph_number(1, N_of_GRAPH_DATA - 1);
		display_graph_number(1, N_of_GRAPH_DATA - 2);
		wtod_5u((char *)disp_moji, count_minute[cpm_data_pos]);				// ̒l
		disp_lcd_G(15, 0, &disp_moji[0]);									// display Dot Matrix LCD
	}

	*disp_item = 0;

}
//*****************************************
// ̃Ot
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_cph_graph(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static unsigned long	max_value=0;
	static unsigned long	range=20;

	if((disp_any_condition == 1)||((*disp_item & DISP_MEAS_CPD_04)!=0)){
		disp_clear_lcd_G();													// Clear Display
		max_value = get_max_value(1);										// US̂̍ől߂
		range = get_range(max_value);										// Ot̃Wiőlj߂
		set_graph_data(1,range,1);											// Otf[^ɂăZbg
		display_graph(1,8);
		display_graph_scale();												// Ot̖ڐ\
		wtod_l7u((char *)disp_moji, range);									// W
		disp_lcd_G(1, 0, &disp_moji[0]);									// display Dot Matrix LCD
		get_pgm_str(&str_cph[0]);											// "cph"
		disp_lcd_G( 9, 0, &disp_moji[0]);									// display Dot Matrix LCD
		if(count_hour[cph_data_pos] == 0xffffffff){							// ̒l
			get_pgm_str(&str_5minus[0]);									// "-----"
			disp_lcd_G(15, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}else{
			wtod_7u((char *)disp_moji, count_hour[cph_data_pos]);			// ̒l
			disp_lcd_G(13, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}
		disp_buz_symble();													// uU[̂nm^nee\
	}else if((*disp_item & DISP_MEAS_CPH_03)!=0){
		set_graph_data(1,range,0);											// ߂Otf[^ɂăZbg
		display_graph_number(1, N_of_GRAPH_DATA - 1);
		display_graph_number(1, N_of_GRAPH_DATA - 2);
		wtod_7u((char *)disp_moji, count_hour[cph_data_pos]);				// ̒l
		disp_lcd_G(13, 0, &disp_moji[0]);									// display Dot Matrix LCD
	}

	*disp_item = 0;

}
//*****************************************
// ̃Ot
//   disp_item: bit0=DISP_MEAS_SEC_00(sec)
//                  bit1=DISP_MEAS_NOW_01(Now cpm)
//                  bit2=DISP_MEAS_CPM_02(cpm)
//                  bit3=DISP_MEAS_CPH_03(cph)
//                  bit4=DISP_MEAS_CPD_04(cpd(day))
//                  bit5=DISP_MEAS_HV_05(hv)
//                  bit6=DISP_MEAS_BAT_06(battry)
//       disp_any_condition: 1=Kw肳ꂽڂ͕\
//*****************************************
void	disp_cpd_graph(unsigned char *disp_item, unsigned char disp_any_condition)
{
	static unsigned long	max_value=0;
	static unsigned long	range=20;

	if((disp_any_condition == 1)||((*disp_item & DISP_MEAS_CPD_07)!=0)){
		disp_clear_lcd_G();													// Clear Display
		max_value = get_max_value(2);										// US̂̍ől߂
		range = get_range(max_value);										// Ot̃Wiőlj߂
		set_graph_data(2,range,1);											// Otf[^ɂăZbg
		display_graph(1,8);
		display_graph_scale();												// Ot̖ڐ\
		wtod_l7u((char *)disp_moji, range);									// W
		disp_lcd_G(1, 0, &disp_moji[0]);									// display Dot Matrix LCD
		get_pgm_str(&str_cpd[0]);											// "cpd"
		disp_lcd_G( 9, 0, &disp_moji[0]);									// display Dot Matrix LCD
		if(count_day[cpd_data_pos] == 0xffffffff){							// ̒l
			get_pgm_str(&str_5minus[0]);									// "-----"
			disp_lcd_G(15, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}else{
			wtod_7u((char *)disp_moji, count_day[cpd_data_pos]);			// ̒l
			disp_lcd_G(13, 0, &disp_moji[0]);								// display Dot Matrix LCD
		}
		disp_buz_symble();													// uU[̂nm^nee\
	}else if((*disp_item & DISP_MEAS_CPD_04)!=0){
		set_graph_data(2,range,0);											// ߂Otf[^ɂăZbg
		display_graph_number(1, N_of_GRAPH_DATA - 1);
		display_graph_number(1, N_of_GRAPH_DATA - 2);
		wtod_7u((char *)disp_moji, count_day[cpd_data_pos]);				// ̒l
		disp_lcd_G(13, 0, &disp_moji[0]);									// display Dot Matrix LCD
	}

	*disp_item = 0;

}
//*****************************************
// obeږ̕\
// _x : Position X(0 -- 19)
//      y : Position Y(0 -- 7)
// display: 0=A1=\
//*****************************************
void	disp_bat_title(unsigned char x, unsigned char y, unsigned char display)
{
	if(display == 0){
		get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
		disp_lcd_G( x, y,&disp_moji[6]);				// \
	}else{
		get_pgm_str(&str_bat[0]);						// vÖ̕("BAT")擾
		disp_lcd_G( x, y,&disp_moji[0]);				// \
	}
}
//*****************************************
// 荀ڂ̃^Cg\ij
//*****************************************
void	disp_meas_title_full(void)
{
	disp_clear_lcd_G();									// Clear Display

	// Line No.0
	disp_one_char_lcd_G(14, 0, ':');					// display Dot Matrix LCD  One Char
	disp_one_char_lcd_G(17, 0, ':');					// display Dot Matrix LCD  One Char

	// Line No.1
	get_pgm_str(&str_cpm[0]);							// vÖ̕("cpm")擾
	disp_lcd_G( 0,1,&disp_moji[0]);						// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(15,1,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(18,1,&disp_moji[0]);						// \

	// Line No.2
	get_pgm_str(&str_average[0]);						// vÖ̕("Ave.")擾
	disp_lcd_G( 2,2,&disp_moji[0]);						// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(15,2,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(18,2,&disp_moji[0]);						// \

	// Line No.3
	get_pgm_str(&str_cph[0]);							// vÖ̕("cph")擾
	disp_lcd_G( 0,3,&disp_moji[0]);						// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(15,3,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(18,3,&disp_moji[0]);						// \

	// Line No.4
	get_pgm_str(&str_cpd[0]);							// vÖ̕("cpd")擾
	disp_lcd_G( 0,4,&disp_moji[0]);						// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(15,4,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(18,4,&disp_moji[0]);						// \

	// Line No.6
	get_pgm_str(&str_hv_moni[0]);						// vÖ̕("HV_moni")擾
	disp_lcd_G( 0,6,&disp_moji[0]);						// \
	disp_one_char_lcd_G( 7, 6, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G(11,6,&disp_moji[0]);						// \
	get_pgm_str(&str_hv_out[0]);						// vÖ̕("HV_out")擾
	disp_lcd_G(13,6,&disp_moji[3]);						// \
	disp_one_char_lcd_G(16, 6, ':');					// display Dot Matrix LCD  One Char

	// Line No.7
	disp_bat_title( 0, 7, 1);							// obeږ̕\
	disp_one_char_lcd_G( 3, 7, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G( 8,7,&disp_moji[0]);						// \

	disp_buz_symble();									// uU[̂nm^nee\

}
//*****************************************
// 荀ڂ̃^Cg\iJEgj
//*****************************************
void	disp_meas_title_count(void)
{
	disp_clear_lcd_G();									// Clear Display

	// Line No.0
	disp_lcd_G( 5,0,(unsigned char*)"N of Count");			// \

	// Line No.1
	disp_lcd_G( 7,1,(unsigned char*)"Now:");				// \

	// Line No.2
	disp_lcd_G( 4,2,(unsigned char*)"Minute:");				// \

	// Line No.3
	disp_lcd_G( 4,3,(unsigned char*)"Hour:");				// \

	// Line No.4
	disp_lcd_G( 5,4,(unsigned char*)"Day:");				// \

	// Line No.5

	// Line No.6
	get_pgm_str(&str_hv_moni[0]);						// vÖ̕("HV_moni")擾
	disp_lcd_G( 1,6,&disp_moji[0]);						// \
	disp_one_char_lcd_G( 8, 6, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G(11,6,&disp_moji[0]);						// \

	// Line No.7
	disp_bat_title( 0, 7, 1);							// obeږ̕\
	disp_one_char_lcd_G( 3, 7, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G( 8,7,&disp_moji[0]);						// \

	disp_buz_symble();									// uU[̂nm^nee\
}
//*****************************************
// 荀ڂ̃^Cg\ir^j
//*****************************************
void	disp_meas_title_usv_h(void)
{
	disp_clear_lcd_G();									// Clear Display

	// Line No.0
	disp_lcd_G( 0,0,(unsigned char*)"Radiation");		// \

	// Line No.1
	disp_lcd_G( 5,1,(unsigned char*)"Now:");			// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,1,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,1,&disp_moji[0]);						// \

	// Line No.2
	disp_lcd_G( 2,2,(unsigned char*)"Minute:");			// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,2,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,2,&disp_moji[0]);						// \

	// Line No.3
	disp_lcd_G( 1,3,(unsigned char*)"Average:");		// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,3,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,3,&disp_moji[0]);						// \

	// Line No.4
	disp_lcd_G( 4,4,(unsigned char*)"Hour:");			// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,4,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,4,&disp_moji[0]);						// \

	// Line No.5
	disp_lcd_G( 5,5,(unsigned char*)"Day:");			// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,5,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,5,&disp_moji[0]);						// \

	// Line No.6
	get_pgm_str(&str_hv_moni[0]);						// vÖ̕("HV_moni")擾
	disp_lcd_G( 2,6,&disp_moji[0]);						// \
	disp_one_char_lcd_G( 8, 6, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G(12,6,&disp_moji[0]);						// \

	// Line No.7
	disp_bat_title( 0, 7, 1);							// obeږ̕\
	disp_one_char_lcd_G( 3, 7, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G( 8,7,&disp_moji[0]);						// \

	disp_buz_symble();									// uU[̂nm^nee\
}
//*****************************************
// 荀ڂ̃^Cg\iȂj
//*****************************************
void	disp_meas_title(void)
{
	disp_clear_lcd_G();									// Clear Display

	// Line No.1
//	get_pgm_str(&str_sec[0]);							// vÖ̕("sec")擾
//	disp_lcd_G(16,1,&disp_moji[0]);						// \
	get_pgm_str(&str_cpm[0]);							// vÖ̕("cpm")擾
	disp_lcd_G(14,1,&disp_moji[0]);						// \

	// Line No.3
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,3,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,3,&disp_moji[0]);						// \

	// Line No.5
	get_pgm_str(&str_average[0]);						// vÖ̕("Ave.")擾
	disp_lcd_G( 0,5,&disp_moji[0]);						// \
	get_pgm_str(&str_uSv[0]);							// vÖ̕("uSv")擾
	disp_lcd_G(14,5,&disp_moji[0]);						// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G(17,5,&disp_moji[0]);						// \

	// Line No.6
	disp_one_char_lcd_G(14, 6, ':');					// display Dot Matrix LCD  One Char
	disp_one_char_lcd_G(17, 6, ':');					// display Dot Matrix LCD  One Char

	// Line No.7
	disp_bat_title( 0, 7, 1);							// obeږ̕\
	disp_one_char_lcd_G( 3, 7, ':');					// display Dot Matrix LCD  One Char
	get_pgm_str(&str_volt[0]);							// vÖ̕("V")擾
	disp_lcd_G( 8,7,&disp_moji[0]);						// \

	disp_buz_symble();									// uU[̂nm^nee\
}

//*****************************************
// ̌̍ő̓߂
//  uln:ɂȂl
//@uln ̌`
//@PONPQRPQRTX̎ ɂȂl 1012312359 ɂȂĂ
//*****************************************
unsigned long	get_max_hi(unsigned long uln)
{
	unsigned long	r;
	unsigned long	tuki;
	unsigned long	nen;

	tuki = ((uln/1000000L) % 100L);		// 
	nen  = ((uln/100000000L) % 100L);	// N

	if((tuki == 4)||(tuki == 6)||(tuki == 9)||(tuki == 11)){		// ̌
		r = 30;
	}else if(tuki == 2){											// 
		if((nen % 4)==0){											// 邤N
			r = 29;
		}else{														// ʂ̔N
			r = 28;
		}
	}else{															// ̌(0,1,3,5,7,8,10,12)
		r = 31;
	}
	return(r);
}
//*****************************************
// ̑Z@킹
//  uln:ɂȂl
//  QRUO̍킹
//@uln ̌`
//@PONPQRPQRTX̎ ɂȂl 1012312359 ɂȂĂ
//*****************************************
unsigned long	jikouku_awase_tasizan(unsigned long uln)
{
	unsigned long	r;
	unsigned long	max_hi;

	// ̂킹
	if( 59L < (uln % 100L)){					// TX𒴂Ă鎞
		r = (uln / 100L) * 100L;
		r += 100L;								// PvX
		r += 0L;								// OOɂ
		uln = r;
	}

	// ̂킹
	if( 23L < ((uln/100L) % 100L)){				// QR𒴂Ă鎞
		r = (uln / 10000L) * 10000L;
		r += 10000L;							// PvX
		r += 0L;								// OOɂ
		r += (uln % 100L);						// ̒l𑫂
		uln = r;
	}

	// ̂킹
	max_hi = get_max_hi(uln);					// ̌̍ő̓߂
	if(max_hi < ((uln/10000)%100)){				// ő̓𒴂Ă鎞
		r = (uln / 1000000L) * 1000000L;
		r += 1000000L;							// PvX
		r += 10000L;							// Pɂ
		r += (uln % 10000L);					// ̒l𑫂
		uln = r;
	}

	// ̂킹
	if( 12 < ((uln/1000000L) % 100L)){		// PQ𒴂Ă鎞
		r = (uln / 100000000L) * 100000000L;
		r += 100000000L;					// NPvX
		r += 1000000L;						// Pɂ
		r += (uln % 1000000L);				// ̒l𑫂
		uln = r;
	}
	return(uln);
}

//*****************************************
// ̑Z
//  uln:錳ɂȂl
//@       uln ̌`
//@       PONPQRPQRTX̎ ɂȂl 1012312359 ɂȂĂ
//  tasibun:l
//@@@@@P̑Z
//@@@@@POȎZ
//@@@@@POOOȎZ
//*****************************************
unsigned long	jikouku_tasizan(unsigned long uln, unsigned long tasibun)
{
	uln += tasibun;
	uln = jikouku_awase_tasizan(uln);		// ̑Z@킹

	return(uln);
}
//*****************************************
// ̈Z@킹
//  uln:ɂȂl
//  QRUO̍킹
//@uln ̌`
//@PONPQRPQRTX̎ ɂȂl 1012312359 ɂȂĂ
//*****************************************
unsigned long	jikouku_awase_hikizan(unsigned long uln)
{
	unsigned long	r;
	unsigned long	max_hi;

	// ̂킹
	if( 59L < (uln % 100L)){					// TX𒴂Ă鎞́iXX̔j
		r = (uln / 100L) * 100L;
		r += 59;								// TXɂ
		uln = r;
	}

	// ̂킹
	if( 23L < ((uln/100L) % 100L)){				// QR𒴂Ă鎞́iXX̔j
		r = (uln / 10000L) * 10000L;
		r += 2300;								// QRɂ
		r += (uln % 100L);						// ̒l𑫂
		uln = r;
	}

	// ̂킹
	if(((uln/10000)%100) == 0){					// O̎
		r = (uln / 1000000L) * 1000000L;
		r -= 1000000L;							// P}CiX
		max_hi = get_max_hi(r);					// ̌̍ő̓߂
		r += max_hi * 10000;					// ő̓ɂ
		r += (uln % 10000L);					// ̒l𑫂
		uln = r;
	}

	// ̂킹
	if( ((uln/1000000L) % 100L) == 0){			// O̎
		r = (uln / 100000000L) * 100000000L;
		r -= 100000000L;						// NP}CiX
		r += 12000000;							// PQɂ
		r += (uln % 1000000L);					// ̒l𑫂
		uln = r;
	}
	return(uln);

}

//*****************************************
// ̈Z
//  uln:錳ɂȂl
//@       uln ̌`
//@       PONPQRPQRTX̎ ɂȂl 1012312359 ɂȂĂ
//  hikubun:l
//@@@@@P̈Z
//@@@@@POÖZ
//@@@@@POOOÖZ
//*****************************************
unsigned long	jikouku_hikizan(unsigned long uln, unsigned long hikibun)
{
	uln -= hikibun;
	uln = jikouku_awase_hikizan(uln);		// ̈Z@킹

	return(uln);
}
//*****************************************
// ۑf[^iPԖ͂PԂƁj̃Ot\
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	graph_cph_save_data(unsigned char cph)
{
	unsigned int	j;
	unsigned char	ucc;
	unsigned int	uc;
	unsigned int	uc_bef;
	unsigned int	ucs;											// ̕\y[W̍ŏiE[j̃f[^̔Ԗ
	unsigned long	ul;
	unsigned long	uls;											// ̕\y[W̍ŏiE[j̃f[^̎
	unsigned long	uln;											// x̃f[^̎̐l
	unsigned long	uln_lo;											// x̃f[^̎̐l̉
	unsigned long	uln_hi;											// x̃f[^̎̐l̏
	unsigned int	saidai;
	unsigned int	saidai_suu;
	unsigned char	end = 0;
	unsigned long	hikubunn;
	unsigned long	max_value=0;
	unsigned long	range=20;
	unsigned long	haba;

	disp_clear_lcd_G();												// Clear Display
	eeprom_busy_wait();
	if(cph == 0){													// PԂƃf[^(cpm)̎
		uc = (unsigned int)eeprom_read_byte(&eep_cpm_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_MINUTE_DATA;
		hikubunn = 1L;
		haba = 0L;
	}else if(cph == 1){												// PԖf[^̎
		uc = (unsigned int)eeprom_read_byte(&eep_cph_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_HOUR_DATA;
		hikubunn = 100L;
		haba = 1L;
	}else{															// Pf[^̎
		uc = (unsigned int)eeprom_read_byte(&eep_cpd_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_DAY_DATA;
		hikubunn = 10000L;
		haba = 100L;
	}
	saidai_suu = 0;

	if(uc == 0xff){													// ۑ
		get_pgm_str(&str_no_data[0]);								// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);									// \

		delay_ms(4000);												// 4000mS Delay
	}else{
		for(;;){
			ucs = uc;
			ucs--;
			if(saidai <= ucs){
				ucs = (saidai - 1);
			}
			eeprom_busy_wait();
			if(cph == 0){														// PԂƃf[^(cpm)̎
				uls = eeprom_read_dword(eep_minute_time_data + ucs);			// PԖf[^̎ǂݏo
			}else if(cph == 1){													// PԖf[^(cph)̎
				uls = eeprom_read_dword(eep_hour_time_data + ucs);				// PԖf[^̎ǂݏo
			}else{																// Pf[^(cpd)̎
				uls = eeprom_read_dword(eep_day_time_data + ucs);				// Pf[^̎ǂݏo
			}
			if((uls == 0L)||(uls == 0xffffffff)){								// f[^
				get_pgm_str(&str_no_data[0]);									// vÖ̕("No Data !!")擾
				disp_lcd_G( 3,1,disp_moji);										// \

				delay_ms(4000);													// 4000mS Delay
				return;
			}
			for(j=0;j<64;j++){
				grh_work_buf[j] = 0L;
			}
			uln = jikouku_tasizan(uls, hikubunn);								// ̑Zîׂ̈̂܂킹j
			for(j= 0; j<60; j++){
				saidai_suu ++;
				if(saidai <= saidai_suu){
					if(j==0){
						return;
					}else{
						break;
					}
				}
				uc_bef = uc;
				uc--;
				if(saidai <= uc){
					uc = (saidai - 1);
				}
				uln = jikouku_hikizan(uln, hikubunn);								// ̈Z
				uln_lo = jikouku_hikizan(uln, haba);								// x̃f[^̎̐l̉(̈Z)
				uln_hi = jikouku_tasizan(uln, haba);								// x̃f[^̎̐l̏(̈Z)
				eeprom_busy_wait();
				if(cph == 0){														// PԂƃf[^(cpm)̎
					ul = eeprom_read_dword(eep_minute_time_data + uc);				// PԖf[^̎ǂݏo
				}else if(cph == 1){													// PԖf[^(cph)̎
					ul = eeprom_read_dword(eep_hour_time_data + uc);				// PԖf[^̎ǂݏo
				}else{																// Pf[^(cpd)̎
					ul = eeprom_read_dword(eep_day_time_data + uc);					// Pf[^̎ǂݏo
				}
				if((ul == 0L)||(ul == 0xffffffff)){									// f[^
					end = 1;
					break;
				}else{
					if( (ul < uln_lo)||(uln_hi < ul) ){								// Ōvfꂽie͈͂𒴂ႢL鎞j
						uc = uc_bef;												// O̔Ԗڂɖ߂
						break;
					}else{
						uln = ul;													// V̎
						eeprom_busy_wait();
						if(cph == 0){														// PԂƃf[^(cpm)̎
							ul = (unsigned long)eeprom_read_word(eep_minute_data + uc);		// PԖf[^̓ǂݏo
							if(ul == 0xffff){
								ul = 0xffffffff;
							}
						}else if(cph == 1){													// PԖf[^(cph)̎
							ul = eeprom_read_dword(eep_hour_data + uc);						// PԖf[^̓ǂݏo
						}else{																// Pf[^(cpd)̎
							ul = eeprom_read_dword(eep_day_data + uc);						// Pf[^̓ǂݏo
						}
						if(ul == 0xffffffff){
							ul = 0L;
						}
						grh_work_buf[j] = ul;
					}
				}
			}
			max_value = get_max_value(3);												// US̂̍ől߂
			range = get_range(max_value);												// Ot̃Wiőlj߂
			set_graph_data(3,range,1);													// SĂOtf[^ɂăZbg
			display_graph(1,8);
			display_graph_scale();														// Ot̖ڐ\
			wtod_l7u((char *)disp_moji, range);											// W
			disp_lcd_G(1, 0, &disp_moji[0]);											// display Dot Matrix LCD
			if(cph == 0){																// PԂƃf[^(cpm)̎
				get_pgm_str(&str_cpm[0]);												// "cpm"
				disp_lcd_G( 0, 7, &disp_moji[0]);										// display Dot Matrix LCD
			}else if(cph == 1){															// PԖf[^(cph)̎
				get_pgm_str(&str_cph[0]);												// "cph"
				disp_lcd_G( 0, 7, &disp_moji[0]);										// display Dot Matrix LCD
			}else{																		// Pf[^(cpd)̎
				get_pgm_str(&str_cpd[0]);												// "cpd"
				disp_lcd_G( 0, 7, &disp_moji[0]);										// display Dot Matrix LCD
			}
			convert_display_date_time(uls);												// unsigned long ̒l\pɕϊ
			disp_lcd_G( 9, 0, &disp_moji[5]);											// display Dot Matrix LCD

			wait_sw_off();																// Q̃XCb`Q@܂ŉiv[v

			// XCb`ꂽi܂ŉiv[vj
			ucc = 10;
			while(1){
				if((PIND & SW_LEFT) == 0){
					delay_ms(50);							// 50mS Delay
					if((PIND & SW_LEFT) == 0){
#ifdef		CONFIG_BACK_LIGHT_ON
						start_back_light();					// obNCg̎nmX^[gs
#endif		//CONFIG_BACK_LIGHT_ON
						break;								// {ɉꂽƂ
					}
				}else if( (PIND & SW_RIGHT) == 0 ){
					delay_ms(100);							// 100mS Delay
					if((PIND & SW_RIGHT) == 0){
						end = 1;
#ifdef		CONFIG_BACK_LIGHT_ON
						start_back_light();					// obNCg̎nmX^[gs
#endif		//CONFIG_BACK_LIGHT_ON
						break;
					}
				}

				delay_ms(100);
				ucc--;
				if(ucc == 0){
					ucc = 10;
					if(tim_1s_back_light != 0){
						tim_1s_back_light--;
					}
				}
#ifdef		CONFIG_BACK_LIGHT_ON
				proc_back_light();							// obNCĝnm^nees
#endif		//CONFIG_BACK_LIGHT_ON
			}
			if(end == 1){
				break;
			}
		}
	}
}

//*****************************************
// ۑf[^iPԖ͂PԂƁj̃Ot\
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	graph_cph_save_data_NO_RTC(unsigned char cph)
{
	unsigned int	j;
	unsigned char	ucc;
	unsigned int	uc;
	unsigned int	uc_bef;
	unsigned int	ucs;											// ̕\y[W̍ŏiE[j̃f[^̔Ԗ
	unsigned long	ul;
	unsigned int	saidai;
	unsigned int	saidai_suu;
	unsigned char	end = 0;
	unsigned long	max_value=0;
	unsigned long	range=20;

	eeprom_busy_wait();
	if(cph == 0){													// PԂƃf[^(cpm)̎
		uc = (unsigned int)eeprom_read_byte(&eep_cpm_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_MINUTE_DATA;
	}else if(cph == 1){												// PԖf[^̎
		uc = (unsigned int)eeprom_read_byte(&eep_cph_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_HOUR_DATA;
	}else{															// Pf[^̎
		uc = (unsigned int)eeprom_read_byte(&eep_cpd_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_DAY_DATA;
	}
	saidai_suu = 0;

	if(uc == 0xff){									// ۑ
		get_pgm_str(&str_no_data[0]);				// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);					// \

		delay_ms(4000);								// 4000mS Delay
	}else{
		for(;;){
			ucs = saidai_suu;
			for(j= 0; j<60; j++){
				saidai_suu ++;
				if(saidai <= saidai_suu){
					if(j==0){
						return;
					}else{
						break;
					}
				}
				uc_bef = uc;
				uc--;
				if(saidai <= uc){
					uc = (saidai - 1);
				}
				eeprom_busy_wait();
				if(cph == 0){														// PԂƃf[^(cpm)̎
					ul = (unsigned long)eeprom_read_word(eep_minute_data + uc);		// PԖf[^̓ǂݏo
					if(ul == 0xffff){
						ul = 0xffffffff;
					}
				}else if(cph == 1){													// PԖf[^(cph)̎
					ul = eeprom_read_dword(eep_hour_data + uc);						// PԖf[^̓ǂݏo
				}else{																// Pf[^(cpd)̎
					ul = eeprom_read_dword(eep_day_data + uc);						// Pf[^̓ǂݏo
				}
				if(ul == 0xffffffff){
					ul = 0L;
				}
				grh_work_buf[j] = ul;
			}
			max_value = get_max_value(3);												// US̂̍ől߂
			range = get_range(max_value);												// Ot̃Wiőlj߂
			set_graph_data(3,range,1);													// SĂOtf[^ɂăZbg
			display_graph(1,8);
			display_graph_scale();														// Ot̖ڐ\
			wtod_l7u((char *)disp_moji, range);											// W
			disp_lcd_G(1, 0, &disp_moji[0]);											// display Dot Matrix LCD
			if(cph == 0){																// PԂƃf[^(cpm)̎
				get_pgm_str(&str_cpm[0]);												// "cpm"
				disp_lcd_G( 9, 0, &disp_moji[0]);										// display Dot Matrix LCD
			}else if(cph == 1){															// PԖf[^(cph)̎
				get_pgm_str(&str_cph[0]);												// "cph"
				disp_lcd_G( 9, 0, &disp_moji[0]);										// display Dot Matrix LCD
			}else{																		// Pf[^(cpd)̎
				get_pgm_str(&str_cpd[0]);												// "cpd"
				disp_lcd_G( 9, 0, &disp_moji[0]);										// display Dot Matrix LCD
			}
			wtod_7u((char *)disp_moji, (unsigned long)ucs);								// ̃OẗԐVԖ
			for(j=0;j<6;j++){
				if(disp_moji[j+1]!=' '){
					disp_moji[j]='-';
					break;
				}
			}
			disp_lcd_G(12, 0, &disp_moji[0]);											// display Dot Matrix LCD

			wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

			// XCb`ꂽi܂ŉiv[vj
			ucc = 10;
			while(1){
				if((PIND & SW_LEFT) == 0){
					delay_ms(50);							// 50mS Delay
					if((PIND & SW_LEFT) == 0){
#ifdef		CONFIG_BACK_LIGHT_ON
						start_back_light();					// obNCg̎nmX^[gs
#endif		//CONFIG_BACK_LIGHT_ON
						break;								// {ɉꂽƂ
					}
				}else if( (PIND & SW_RIGHT) == 0 ){
					delay_ms(100);							// 100mS Delay
					if((PIND & SW_RIGHT) == 0){
						end = 1;
#ifdef		CONFIG_BACK_LIGHT_ON
						start_back_light();					// obNCg̎nmX^[gs
#endif		//CONFIG_BACK_LIGHT_ON
						break;
					}
				}

				delay_ms(100);
				ucc--;
				if(ucc == 0){
					ucc = 10;
					if(tim_1s_back_light != 0){
						tim_1s_back_light--;
					}
				}
#ifdef		CONFIG_BACK_LIGHT_ON
				proc_back_light();							// obNCĝnm^nees
#endif		//CONFIG_BACK_LIGHT_ON
			}
			if(end == 1){
				break;
			}
		}
	}
}

#ifdef		DEBUG_DISP
//*****************************************
// fobOp\
// KX@e͕ύX
// disp_debug
//*****************************************
void	disp_debug(void)
{

}
//*****************************************
// fobOp\
// KX@e͕ύX
// disp_debug2
//*****************************************
void	disp_debug2(void)
{
	wtod_03u(&disp_moji[0], v_ubrr[0]);
	disp_lcd_G( 1, 3, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[1]);
	disp_lcd_G(11, 3, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[2]);
	disp_lcd_G( 1, 4, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[3]);
	disp_lcd_G(11, 4, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[4]);
	disp_lcd_G( 1, 5, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[5]);
	disp_lcd_G(11, 5, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[6]);
	disp_lcd_G( 1, 6, disp_moji);											// display LCD

}
#endif		//DEBUG_DISP
