//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Display.h
//  wb_[t@C
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************

#define		DISP_MEAS_SEC_00		0x01
#define		DISP_MEAS_NOW_01		0x02
#define		DISP_MEAS_CPM_02		0x04
#define		DISP_MEAS_CPH_03		0x08
#define		DISP_MEAS_CPD_04		0x10
#define		DISP_MEAS_HV_05			0x20
#define		DISP_MEAS_BAT_06		0x40
#define		DISP_MEAS_CPD_07		0x80

extern	unsigned char	get_next_num_cpm(void);
extern	unsigned char	get_next_num_cph(void);
extern	unsigned char	get_next_num_cpd(void);
extern	void	disp_meas_data_full(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_meas_data_count(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_meas_data_usv_h(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_meas_data(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_cpm_graph(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_cph_graph(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_cpd_graph(unsigned char *disp_item, unsigned char disp_any_condition);
extern	void	disp_bat_title(unsigned char x, unsigned char y, unsigned char display);
extern	void	disp_meas_title_full(void);
extern	void	disp_meas_title_count(void);
extern	void	disp_meas_title_usv_h(void);
extern	void	disp_meas_title(void);
extern	void	disp_buz_symble(void);
extern	void	graph_cph_save_data(unsigned char cph);
extern	void	graph_cph_save_data_NO_RTC(unsigned char cph);

#ifdef		DEBUG_DISP
extern	void			disp_debug(void);
extern	void			disp_debug2(void);
#endif		//DEBUG_DISP
