//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:EEPROM.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include		<avr/interrupt.h>
#include		<avr/io.h>
#include		<avr/eeprom.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"Serial.h"
#include		"LCD.h"
#include		"Display.h"
#include		"Setting.h"

#include		"EEPROM.h"

// **********************************************************
// ******************** Save Data(EEPROM) *******************
// **********************************************************

unsigned char	eep_cpd_write_pos EEMEM = 0;						// PƂɕۑ鎞́@ۑʒu
unsigned char	eep_cph_write_pos EEMEM = 0;						// PԂƂɕۑ鎞́@ۑʒu
unsigned char	eep_cpm_write_pos EEMEM = 0;						// PԂƂɕۑ鎞́@ۑʒu
unsigned char	eep_dumy1 EEMEM;									// _~[
unsigned char	eep_buz_on[16] EEMEM = {0,0,0};						// uU[gۂ
unsigned char	eep_back_light_mode[16] EEMEM = {1,1,1};			// obNCg̏^_[hiOFneeAPF`tsnAQFnm)
unsigned int	eep_hv_hosei_spn[8] EEMEM = {						// guj^l𐳊mɂׂ̕␳lXp
					HV_HOSEI_SPN_DEFAULT,
					HV_HOSEI_SPN_DEFAULT,
					HV_HOSEI_SPN_DEFAULT,
				};
unsigned int	eep_hv_hosei_ofs[8] EEMEM = {						// guj^l𐳊mɂׂ̕␳lItZbg
					HV_HOSEI_OFS_DEFAULT,
					HV_HOSEI_OFS_DEFAULT,
					HV_HOSEI_OFS_DEFAULT,
				};
unsigned int	eep_hv_target_volt[8] EEMEM = {						// o͓diuPʁj
					HV_DEFAULT,
					HV_DEFAULT,
					HV_DEFAULT,
				};
unsigned int	eep_cpm_to_uSv_spn[8] EEMEM = {						// cpm_to_uSv_spn ZlXpiPO{̒lj
					CPM_uSv_h_SPN_DEFAULT,
					CPM_uSv_h_SPN_DEFAULT,
					CPM_uSv_h_SPN_DEFAULT,
				};
unsigned int	eep_cpm_to_uSv_ofs[8] EEMEM = {						// cpm_to_uSv_ofs ZItZbg(JEgl炱̒l)
					CPM_uSv_h_OFS_DEFAULT,
					CPM_uSv_h_OFS_DEFAULT,
					CPM_uSv_h_OFS_DEFAULT,
				};

unsigned long	eep_day_data[N_of_EEP_DAY_DATA] EEMEM ={			// P̃JEglۑ
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
				};
unsigned long	eep_hour_data[N_of_EEP_HOUR_DATA] EEMEM = {			// PԖ̃JEglۑ
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
				};
unsigned int	eep_minute_data[N_of_EEP_MINUTE_DATA] EEMEM = {		// P̃JEglۑ̓
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
					0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
				};
unsigned long	eep_day_time_data[N_of_EEP_DAY_DATA] EEMEM ={			// P̃JEglۑ̓
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
				};
unsigned long	eep_hour_time_data[N_of_EEP_HOUR_DATA] EEMEM = {			// PԖ̃JEglۑ̓
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
				};
unsigned long	eep_minute_time_data[N_of_EEP_MINUTE_DATA] EEMEM = {		// P̃JEglۑ̓
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
					0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
				};



//*****************************************
// (unsigned int)
// uc0: mDO̒l
// uc1: mDP̒l
// uc2: mDQ̒l
// def: SĈĂ Cl
//*****************************************
unsigned int	tasuuketu_ui(unsigned int ui0, unsigned int ui1, unsigned int ui2, unsigned int def)
{
	unsigned int	ui;

	if(ui0 == ui1){
		ui = ui0;
	}else if(ui0 == ui2){
		ui = ui0;
	}else if(ui1 == ui2){
		ui = ui1;
	}else{
		ui = def;
	}

	return(ui);
}
