//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Graph.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
// for TG12864E-01XWBV & SG12864A (Controler:S6B0107)
//
//  2011/09/15 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include		<avr/io.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"LCD.h"
#include		"Timer.h"
#include		"Utility.h"

#include		"Graph.h"

#define			GRAPH_Y_MAX						63					// őxʒuiO`̒lw͈̔͂ɂȂjin[hŌ܂j
#define			GRAPH_X_MAX						127					// őwʒuiO`̒lx͈̔͂ɂȂjin[hŌ܂j
#define			GRAPH_BLOCK_MAX					63					// PubN̍őwʒuin[hŌ܂j

#define			GRAPH_OFFSET_X					0					// Ot\ItZbg@wʒu
#define			GRAPH_OFFSET_Y					8					// Ot\ItZbg@xʒuiO`Wj
unsigned char	gGraph_data[N_of_GRAPH_DATA];						// Otf[^ mOn[ɕ\Al̂Oɕ\B
static	unsigned char	sOffset_y_mask;								// ItZbg|ɖ_Ot̉NAl
static	unsigned char	ggd[8]={0,0,0,0,0,0,0,0};					// [0]  D0 ԏ̃hbgA[7]D7ԉ̃hbg
// ************************************
// Ot ݒ
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	graph_init(void)
{
	unsigned char	i;
	unsigned char	d;

	sOffset_y_mask = 0xff;										// ItZbg|ɖ_Ot̉NAl
	for(i=0,d=0x7f;i<GRAPH_OFFSET_Y;i++,d >>= 1){
		sOffset_y_mask &= d;
	}

}

// *****************************************************************************
// cPhbg̐\
//  Fx@ʒuihbgPʁA[OŁ@O||PQVj
//  @@@	f[^ ggd[8] ɓĂ@[0]  D0 ԏ̃hbgA[7]D7ԉ̃hbg
// *****************************************************************************
void	display_graph_tate(unsigned char x)
{
	unsigned char	block;							// OFubNAPFEubN
	unsigned char	x_adr;							// \l̂wAhX(0 -- 63)
	unsigned char	l_uc;
	unsigned char	i;

	if(x <= GRAPH_BLOCK_MAX){						// ʒuPubNȉ̎
		block = 0;									// ubN
		x_adr = x;
	}else{											// ʒuPubN𒴂鎞
		block = 1;									// EubN
		x_adr = x - (GRAPH_BLOCK_MAX + 1);
	}

	for(i=0;i<7;i++){								// o𓮂͂bƂogŁAoȂƃ_
		l_uc = (0x40 | x_adr);
		lcd_G_cmd_out(block, l_uc);					// Column Address Set

		l_uc = (0xb8 | i);
		lcd_G_cmd_out(block, l_uc);					// Page Set
		lcd_G_data_out(block, ggd[i]);				// Data
	}
}
// *****************************************************************************
// Ot̖ڐ\
//  Fx@ʒuihbgPʁA[OŁ@O||Vj
//  @@@	̒͏cTWhbgAPQOhbgɌ߂
//  @@@@c͏@͕`@ڐ݂̂
// *****************************************************************************
void	display_graph_scale(void)
{
	unsigned char	i;

	// w
	ggd[0]=0xe0;
	for(i=1;i<7;i++){
		ggd[i]=0xff;
	}
	ggd[7]=0x00;
	display_graph_tate(7);							// cPhbg̐\

	// wڐ
	ggd[0]=0x20;										// 63 --> 56
	ggd[1]=0x00;										// 55 --> 48
	ggd[2]=0x02;										// 47 --> 40
	ggd[3]=0x40;										// 39 --> 32
	ggd[4]=0x00;										// 31 --> 24
	ggd[5]=0x08;										// 23 --> 15
	ggd[6]=0x00;										// 15 -->  8
	ggd[7]=0x00;										//  7 -->  0
	display_graph_tate(6);							// cPhbg̐\
	display_graph_tate(5);							// cPhbg̐\

	ggd[0]=0x20;										// 63 --> 56
	ggd[1]=0x00;										// 55 --> 48
	ggd[2]=0x00;										// 47 --> 40
	ggd[3]=0x40;										// 39 --> 32
	ggd[4]=0x00;										// 31 --> 24
	ggd[5]=0x00;										// 23 --> 15
	ggd[6]=0x00;										// 15 -->  8
	ggd[7]=0x00;										//  7 -->  0
	display_graph_tate(4);							// cPhbg̐\
	display_graph_tate(3);							// cPhbg̐\


	disp_moji[0] = '-';								// "-15"
	disp_moji[1] = '1';
	disp_moji[2] = '5';
	disp_moji[3] = 0;
	disp_lcd_G(14, 7, &disp_moji[0]);

	disp_moji[0] = '-';								// "-30"
	disp_moji[1] = '3';
	disp_moji[2] = '0';
	disp_moji[3] = 0;
	disp_lcd_G( 9, 7, &disp_moji[0]);

	disp_moji[0] = '-';								// "-45"
	disp_moji[1] = '4';
	disp_moji[2] = '5';
	disp_moji[3] = 0;
	disp_lcd_G( 4, 7, &disp_moji[0]);

}
// *****************************************************************************
// ̃f[^̃Ot\
//  F@ʒuihbgPʁA[OŁ@O||PQVj
//  F@ʒuihbgPʁA[OŁ@O||URj
//  F@OOtAP_Ot
// *****************************************************************************
void	display_graph_one(unsigned char x, unsigned char y, unsigned char mode)
{
	unsigned char	block;														// OFubNAPFEubN
	unsigned char	x_adr;														// \l̂wAhX(0 -- 63)
	unsigned char	y_page;														// \l̂xy[W(0 -- 7)
	unsigned char	d;
	int				i;
	unsigned char	l_uc;
	unsigned char	gd[8]={0,0,0,0,0,0,0,0};									// [0]  D0 ԏ̃hbgA[7]D7ԉ̃hbg

	if(x <= GRAPH_BLOCK_MAX){													// ʒuPubNȉ̎
		block = 0;																// ubN
		x_adr = x;
	}else{																		// ʒuPubN𒴂鎞
		block = 1;																// EubN
		x_adr = x - (GRAPH_BLOCK_MAX + 1);
	}

	if( (GRAPH_OFFSET_X <= x_adr)&&(x_adr <= GRAPH_BLOCK_MAX) ){				// wʒuItZbgȏŁ@̃ubN̎́@lo͂
		if(64 <= y){															// I[o[̒l͓łɂ
			y = 63;
		}
		y_page = 7 - (y / 8);
		d = (0x80 >> (y % 8));
		gd[y_page] = d;
		if(mode != 0){															// _Ot͈̎ȉ̍׍Hs
			y_page = 7 - (y / 8);
			d = (0x80 >> (y % 8));
			gd[y_page] = d;
			for(i=7;i>=0;i--){													// Ot̉T
				if(gd[i] == 0){													// l̏ꏊłȂ
					gd[i] = 0xff;												// SăhbgŖ߂
				}else{															// l̏ꏊ̎
					d = 0x80;
					for(l_uc = 0;l_uc < 8;l_uc++,d >>=1 ){						// W܂킷iWrbgj
						if((gd[i] & d) != 0){									// lƓɂȂ
							break;												// @I
						}else{													// lƓɂȂ܂	
							gd[i] |= d;											// @hbg𖄂߂
						}
					}
					break;														// Ii[v甲j
				}
			}
			gd[7] &= sOffset_y_mask;											// ItZbg̕NAl
		}
	}
	for(i=0;i<8;i++){															// o𓮂͂bƂogŁAoȂƃ_
		l_uc = (0x40 | x_adr);													// Column Address Set
		lcd_G_cmd_out(block, l_uc);												// Column Address Set

		l_uc = (0xb8 | i);														// Page Set
		lcd_G_cmd_out(block, l_uc);												// Page Set
		lcd_G_data_out(block, gd[i]);											// Data
	}
}

// *****************************************************************************
// Ot\iAEShbg͕\ȂB㑤̓`̕\ɂȂj
//  F@OOtAP_Ot
//  @@@Q@\n߂ԍ(0 --> N_of_GRAPH_DATA-1 )
//   \f[^́@fQmnɗL镨Sĕ\
//   \ʒú@RhbgɃItZbg@O̒l͉̎Rhbgڂɕ\
//   AAől͂UOŁ@ȏ͂UOƂB
//  
// *****************************************************************************
void	display_graph(unsigned char mode, unsigned char start_num)
{
	unsigned char	i;
	unsigned char	d;

	if(N_of_GRAPH_DATA <= start_num){
		start_num = 0;
	}
	for(i=start_num; i<N_of_GRAPH_DATA; i++){
		d = gGraph_data[i];
		display_graph_one(i + GRAPH_OFFSET_X, d + GRAPH_OFFSET_Y, mode);		// ̃f[^̃Ot\
	}
}
// *****************************************************************************
// Ot\iAEShbg͕\ȂB㑤̓`̕\ɂȂj
//  F@OOtAP_Ot
//        @@\f[^ԍ@O`(N_of_GRAPH_DATA-1)
//   \f[^́@fQmnɗL镨wԍ̕\
//   \ʒú@RhbgɃItZbg@O̒l͉̎Rhbgڂɕ\
//   AAől͂UOŁ@ȏ͂UOƂB
//  
// *****************************************************************************
void	display_graph_number(unsigned char mode, unsigned char num)
{
	unsigned char	d;

	if(N_of_GRAPH_DATA <= num){
		num = (N_of_GRAPH_DATA - 1);
	}
	d = gGraph_data[num];
	display_graph_one(num + GRAPH_OFFSET_X, d + GRAPH_OFFSET_Y, mode);		// ̃f[^̃Ot\
}

