//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:LCD.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//@kbc͂PQWUShbgOtBbNW[gp
//    TG12864E-01XWBV or SG12864ASLB-GB-R01
//
//@ȉkbcɕKvȐMꗗ
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include		<avr/io.h>
#include		<avr/pgmspace.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"Serial.h"
#include		"Utility.h"
#include		"Setting.h"
#include		"Comm1.h"
#include		"Timer.h"

#include		"Pfont5x7.h"
#include		"Pfont10x16.h"
#include		"LCD.h"


unsigned int	disp_write_data_pos;													// \pݎMf[^|WV
unsigned int	read_data_pos;															// ǂݏoMf[^JE^[
unsigned int	disp_end_pos;
unsigned char	disp_hex;																// 1:PUi\
unsigned char	disp_moji[21];															// kbc\
unsigned char	n_of_disp_data = 20;													// kbc\鐔̍ő吔
unsigned char	n_of_one_line_disp_data = 5;											// Psɕ\f[^
unsigned char	n_of_line = 8;															// kbc\s
unsigned char	n_of_disp_data_pass = 8;												// oߎԗL̂kbc\鐔̍ő吔
unsigned char	n_of_one_line_disp_data_pass = 2;										// oߎԗL̂Psɕ\f[^
unsigned char	set_back_light;															// obNCgnm^nee


// ************************************* Graphic LCD Accese *********************
unsigned char	c_data0[10];
unsigned char	c_data1[10];

unsigned char	hidarimuki[4]={
	0b00000100,								// '<'
	0b00001010,
	0b00010001,
	0b00000000
};

unsigned char	migimuki[4]={
	0b01000101,								// '>'
	0b00101001,
	0b00010001,
	0b00000001
};


//******************************
// Get Character Bit Data
// 5x7 Font
//  Get Data Save to c_data0[5];
//******************************
static void	get_asc_data(unsigned char uc)
{
	unsigned short	us;

	us = uc;

	c_data0[0] = pgm_read_byte(&(font5x7[us * 5 + 0]));
	c_data0[1] = pgm_read_byte(&(font5x7[us * 5 + 1]));
	c_data0[2] = pgm_read_byte(&(font5x7[us * 5 + 2]));
	c_data0[3] = pgm_read_byte(&(font5x7[us * 5 + 3]));
	c_data0[4] = pgm_read_byte(&(font5x7[us * 5 + 4]));
}
//******************************
// Get Character Bit Data
// 10x16 Font
//  Get Data Save to c_data0[10](㑤j & c_data1[10]ij
//******************************
static void	get_asc_10x16_data(unsigned char uc)
{
	unsigned short	us;
	unsigned char	i;

	if(uc == 0x01){
		us = uc;
	}else if(uc == 0x02){
		us = uc;
	}else if(uc < '-'){
		us = 0;
	}else if(':' < uc){
		us = 0;
	}else{
		us = (uc - '-') + 2;
	}

	for(i=0;i<10;i++){
		c_data0[i] = pgm_read_byte(&(font10x16[us * (10*2) + i*2 + 1]));
		c_data1[i] = pgm_read_byte(&(font10x16[us * (10*2) + i*2 + 0]));
	}
}

//******************************
// LCD Wait Busy
//
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
//
//
// \߁@brP͂brQ͐ݒ肵Ă
// d̏グ̑OɃfB[KvLiȂƓ삪j
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_wait_busy(void)
{
	unsigned char	l_uc;
	unsigned char	i;

	e_low();																// E Sig:Low

	select_port27_input();													// DB2 -- DB7 Input
	select_port01_input();													// DB0 -- DB1 Input
	output_port27 |= 0xfc;													// DB2 -- DB7 Pullup
	output_port01 |= 0x03;													// DB0 -- DB1 Pullup
	select_instruction();													// D/I* Sig:Low
	select_read();															// R/W* Sig:High

	delay_1us(1);															// fB[
	for(i=0;i<10;i++){														// ̃[v͂قƂǂPłɂȂBPOɂȂُ͈̂펖
		e_high();															// E Sig:High
		delay_1us(1);														// fB[
		l_uc = input_port27;
		e_low();															// E Sig:Low

		if((l_uc & (1 << PINC7)) == 0){										// Check Busy 0:Ready
			break;
		}
		delay_1us(1);														// fB[
	}
	output_port27 &= ~0xfc;													// DB2 -- DB7 Pullup OFF
	output_port01 &= ~0x03;													// DB0 -- DB1 Pullup OFF

	if( 10<= i){
		lcd_error();
	}
}
//******************************
// LCD Data Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Output Data(D0 -- D7)
//  rs : RS bit Data(0=Command, 1=Data)
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
//
// d̏グ̑OɃfB[KvLiȂƓ삪j
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_one_out(unsigned char cs, unsigned char uc, int rs)
{
	if(cs == 0){															// CS1
		cs2_off();															// CS2 Sig:Low
		cs1_on();															// CS1 Sig:High
	}else{																	// CS2
		cs1_off();															// CS1 Sig:Low
		cs2_on();															// CS2 Sig:High
	}

	lcd_G_wait_busy();														// LCD Wait Busy

	select_port27_output();													// DB2 -- DB7 Output
	select_port01_output();													// DB0 -- D01 Output

	select_write();															// R/W* Sig:Low
	if((rs & 0x01) == 0){													// RS:0(Command)
		select_instruction();												// D/I* Sig:Low
	}else{																	// RS:1(Data)
		select_data();														// D/I* Sig:High
	}

	output_port27 &= ~mask_data27;
	output_port27 |= (uc & mask_data27);									// Output Data Set DB2 -- DB7
	output_port01 &= ~mask_data01;
	output_port01 |= (uc & mask_data01);									// Output Data Set DB0 -- DB1

	delay_1us(1);															// fB[
	e_high();																// E Sig:High
	delay_1us(1);															// fB[
	e_low();																// E Sig:Low
}
//******************************
// LCD Command Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Command Data(D0 -- D7)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	lcd_G_cmd_out(unsigned char cs, unsigned char uc)
{
	lcd_G_one_out(cs, uc, 0);
}
//******************************
// LCD Data Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Data(D0 -- D7)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	lcd_G_data_out(unsigned char cs, unsigned char uc)
{
	lcd_G_one_out(cs, uc, 1);
}
//******************************
// LCD Data In
//  ߂l : Data(D0 -- D7)
//  \߁@ǂݏoꏊioA`j͎wς݂̎
// *****************************
unsigned char	lcd_G_data_in(void)
{
	unsigned char	l_uc27;
	unsigned char	l_uc01;
	unsigned char	l_uc;

	lcd_G_wait_busy();														// LCD Wait Busy

	e_low();																// E Sig:Low

	select_port27_input();													// DB2 -- DB7 Input
	select_port01_input();													// DB0 -- DB1 Input
	output_port27 |= 0xfc;													// DB2 -- DB7 Pullup
	output_port01 |= 0x03;													// DB0 -- DB1 Pullup
	select_data();															// D/I* Sig:High
	select_read();															// R/W* Sig:High

	delay_1us(1);															// fB[
	e_high();																// E Sig:High
	delay_1us(1);															// fB[
	l_uc27 = input_port27;
	l_uc01 = input_port01;
	e_low();																// E Sig:Low

	output_port27 &= ~0xfc;													// DB2 -- DB7 Pullup OFF
	output_port01 &= ~0x03;													// DB0 -- DB1 Pullup OFF

	l_uc  = (l_uc27 & mask_data27);
	l_uc |= (l_uc01 & mask_data01);

	return(l_uc);
}
//******************************
// Init. LCD
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
// *****************************
void	init_lcd_G(void)
{
	DDRB |= (1 << DDB2);																				// Port-B Bit2(Back Light) : Output

	DDRA |= ((1 << DDA0) | (1 << DDA1) | (1 << DDA2) | (1 << DDA3) | (1 << DDA4) | (1 << DDA5));		// RST*, D/I*, E, CS1, CS2, R/W* Output
	select_port27_output();																				// LCD-DB2 -- LCD-DB7 Output
	select_port01_output();																				// LCD-DB0 -- LCD-DB1 Output
	e_low();																							// E Sig:Low
	select_instruction();																				// D/I* Sig:Low
	cs2_off();																							// CS2 Sig:Low
	cs1_off();																							// CS1 Sig:Low
	select_write();																						// R/W* Sig:Low

	rst_on();																							// Reset* Sig:Low
	delay_ms(100);
	rst_off();																							// Reset* Sig:High

	delay_ms(100);

	lcd_G_cmd_out(0, 0xc0);																				// CS1, Display Start Line:0
	lcd_G_cmd_out(0, 0x3f);																				// CS1, Display ON
	lcd_G_cmd_out(1, 0xc0);																				// CS2, Display Start Line:0
	lcd_G_cmd_out(1, 0x3f);																				// CS2, Display ON
}
//******************************
// Clear Display
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_clear_lcd_G(void)
{
	unsigned char	x;
	unsigned char	y;

	for(y=0;y < 8;y++){
		lcd_G_cmd_out(0, (0xb8 | y));			// CS1 Page Set
		lcd_G_cmd_out(0, 0x40);					// CS1 Column Address Set
		for(x=0;x < 64; x++){
			lcd_G_data_out(0, 0x00);
		}

		lcd_G_cmd_out(1, (0xb8 | y));			// CS2 Page Set
		lcd_G_cmd_out(1, 0x40);					// CS2 Column Address Set
		for(x=0;x < 64; x++){
			lcd_G_data_out(1, 0x00);
		}
	}
}
//******************************
// display LCD 4 Line
//  grph_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 7)
//  uc : Line Data
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_4_line_lcd_G(unsigned char grph_x, unsigned char pos_y, unsigned char *uc)
{
	unsigned char	x;
	unsigned char	cs;

	if(grph_x < 64){						// CS1
		x = grph_x;
		cs = 0;
	}else{									// CS2
		x = grph_x - 64;
		cs = 1;
	}
	lcd_G_cmd_out(cs, (0xb8 | pos_y));		// CS1 or 2  Page Set
	lcd_G_cmd_out(cs, (0x40 | x));			// CS1 or 2  Column Address Set
	lcd_G_data_out(cs, *(uc+0));
	lcd_G_data_out(cs, *(uc+1));
	lcd_G_data_out(cs, *(uc+2));
	lcd_G_data_out(cs, *(uc+3));
}
//******************************
// display LCD One charcter
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_one_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	x;
	unsigned char	cs;
	unsigned char	l_uc;

	get_asc_data(uc);						// Get Character Bit Data
	if(pos_x < 10){							// CS1
		x = (pos_x * 6 +4);
		cs = 0;
	}else{									// CS2
		x = ((pos_x - 10) * 6);
		cs = 1;
	}
	l_uc = (0xb8 | pos_y);					// Page Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Page Set
	l_uc = (0x40 | x);						// Column Address Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Column Address Set
	lcd_G_data_out(cs, c_data0[0]);
	lcd_G_data_out(cs, c_data0[1]);
	lcd_G_data_out(cs, c_data0[2]);
	lcd_G_data_out(cs, c_data0[3]);
	lcd_G_data_out(cs, c_data0[4]);
	lcd_G_data_out(cs, 0x00);
}
//******************************
// display LCD One charcteri]\j
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  uc : Charcter
//    E\sb`͂UhbgitHgԂPhbgLj
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_one_char_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	x;
	unsigned char	cs;
	unsigned char	l_uc;

	get_asc_data(uc);						// Get Character Bit Data
	if(pos_x < 10){							// CS1
		x = (pos_x * 6 +4);
		cs = 0;
	}else{									// CS2
		x = ((pos_x - 10) * 6);
		cs = 1;
	}
	l_uc = (0xb8 | pos_y);					// Page Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Page Set
	l_uc = (0x40 | x);						// Column Address Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Column Address Set
	lcd_G_data_out(cs, c_data0[0] ^ 0xff);
	lcd_G_data_out(cs, c_data0[1] ^ 0xff);
	lcd_G_data_out(cs, c_data0[2] ^ 0xff);
	lcd_G_data_out(cs, c_data0[3] ^ 0xff);
	lcd_G_data_out(cs, c_data0[4] ^ 0xff);
	lcd_G_data_out(cs, 0xff);
}
//******************************
// display LCD One charcter(16x10 Font)
//  pos_x : Position X(0 -- 9)
//  pos_y : Position Y(0 -- 3)
//  uc : Charcter
//    E\sb`͂PQhbgitHgԂQhbgLj
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_one_10x16_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	x;
	unsigned char	cs;
	unsigned char	l_uc;
	unsigned char	i;

	get_asc_10x16_data(uc);					// Get Character 10x16 Bit Data
	if(pos_x < 5){							// CS1
		x = (pos_x * 12 + 4);
		cs = 0;
	}else{									// CS2
		x = ((pos_x - 5) * 12);
		cs = 1;
	}
	l_uc = (0xb8 | (pos_y * 2));			// Page Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Page Set
	l_uc = (0x40 | x);						// Column Address Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Column Address Set
	for(i=0;i<10;i++){
		lcd_G_data_out(cs, c_data0[i]);
	}
	lcd_G_data_out(cs, 0x00);
	lcd_G_data_out(cs, 0x00);

	l_uc = (0xb8 | (pos_y * 2 + 1));		// Page Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Page Set
	l_uc = (0x40 | x);						// Column Address Set
	lcd_G_cmd_out(cs, l_uc);				// CS1 or 2  Column Address Set
	for(i=0;i<10;i++){
		lcd_G_data_out(cs, c_data1[i]);
	}
	lcd_G_data_out(cs, 0x00);
	lcd_G_data_out(cs, 0x00);
}
//******************************
// display LCD(20char x 8Line)
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  ucp : String(termnate 0x00)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(19 < pos){
			break;
		}
		disp_one_char_lcd_G(pos, pos_y, *ucp);
		ucp++;
		pos++;
	}
}
//******************************
// display LCD(20char x 8Line, ]\)
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  ucp : String(termnate 0x00)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(19 < pos){
			break;
		}
		disp_one_char_lcd_G_reverse(pos, pos_y, *ucp);
		ucp++;
		pos++;
	}
}
//******************************
// display LCD(10char x 4Line)
//  pos_x : Position X(0 -- 9)
//  pos_y : Position Y(0 -- 3)
//  ucp : String(termnate 0x00)
//   '.' '/' '0' '1' '2' '3' '4' '5' '6' '7' '8' '9' ':' 
//    ꕶPƓꕶQƃXy[XɌ
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_lcd_10x16_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	if(pos_y <= 3){
		pos = pos_x;
		while(*ucp != 0x00){				// String Data Out
			if(9 < pos){
				break;
			}
			disp_one_10x16_char_lcd_G(pos, pos_y, *ucp);
			ucp++;
			pos++;
		}
	}
}
//******************************
// display LCD 
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_direction_signe_lcd_G(void)
{
//	disp_4_line_lcd_G(124, 1, hidarimuki);
//	disp_4_line_lcd_G(124, 3, hidarimuki);
//	disp_4_line_lcd_G(124, 5, hidarimuki);
//	disp_4_line_lcd_G(124, 7, hidarimuki);

	disp_4_line_lcd_G(0, 1, hidarimuki);
	disp_4_line_lcd_G(0, 3, hidarimuki);
	disp_4_line_lcd_G(0, 5, hidarimuki);
	disp_4_line_lcd_G(0, 7, hidarimuki);

	disp_4_line_lcd_G(0, 0, migimuki);
	disp_4_line_lcd_G(0, 2, migimuki);
	disp_4_line_lcd_G(0, 4, migimuki);
	disp_4_line_lcd_G(0, 6, migimuki);
}

//******************************
// Back Light ON/OFF
//   lon: 0=OFF, 1=ON
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
// *****************************
void	back_light(unsigned char lon)
{
	if(lon == 0){
		PORTB &=  ~(1 << PB2);									// Back Light FET OFF
	}else{
		PORTB |=  (1 << PB2);									// Back Light FET ON
	}
}

// tHg`FbN\
//******************************
// display Font LCD(20char x 8Line)
//  Code 0x00 --> 0x7f
// *****************************
void	disp_lcd_G_font_check1(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0;
	for(y=0;y<8;y++){
		for(x=0;x<16;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}

//******************************
// display Font LCD(20char x 8Line)
//  Code 0x80 --> 0xff
// *****************************
void	disp_lcd_G_font_check2(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0x80;
	for(y=0;y<8;y++){
		for(x=0;x<16;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}
