//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:LCD.h
//  wb_[t@C
//
// for TG12864E-01XWBV & SG12864A (Controler:S6B0107)
//
//
//  PA0: LCD-R/W*
//  PA1: LCD-CS2
//  PA2: LCD-CS1
//  PA3: LCD-E
//  PA4: LCD-D/I*
//  PA5: LCD-RST*
//
//  PB0: LCD-DB0
//  PB1: LCD-DB1
//  PB2: LCD-Back Light(H=ON, L=OFF)
//
//  PC2: LCD-DB2
//  PC3: LCD-DB3
//  PC4: LCD-DB4
//  PC5: LCD-DB5
//  PC6: LCD-DB6
//  PC7: LCD-DB7
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
// ******** MACRO ********
#define	rst_on()				(PORTA &= ~(1 << PA5))						// Reset* Sig:Low
#define	rst_off()				(PORTA |=  (1 << PA5))						// Reset* Sig:High
#define	select_instruction()	(PORTA &= ~(1 << PA4))						// D/I* Sig:Low
#define	select_data()			(PORTA |=  (1 << PA4))						// D/I* Sig:High
#define	e_low()					(PORTA &= ~(1 << PA3))						// E Sig:Low
#define	e_high()				(PORTA |=  (1 << PA3))						// E Sig:High
#define	cs1_on()				(PORTA |=  (1 << PA2))						// CS1 Sig:High
#define	cs1_off()				(PORTA &= ~(1 << PA2))						// CS1 Sig:Low
#define	cs2_on()				(PORTA |=  (1 << PA1))						// CS2 Sig:High
#define	cs2_off()				(PORTA &= ~(1 << PA1))						// CS2 Sig:Low
#define	select_read()			(PORTA |=  (1 << PA0))						// R/W* Sig:High
#define	select_write()			(PORTA &= ~(1 << PA0))						// R/W* Sig:Low
#define	select_port27_input()	(DDRC &= ~( (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7)))		// LCD-DB2 -- LCD-DB7 Input
#define	select_port01_input()	(DDRB &= ~( (1 << DDB0) | (1 << DDB1)))		// LCD-DB0 -- LCD-DB1 Input
#define	select_port27_output()	(DDRC |=  ( (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7)))		// LCD-DB2 -- LCD-DB7 Output
#define	select_port01_output()	(DDRB |=  ( (1 << DDB0) | (1 << DDB1)))		// LCD-DB0 -- LCD-DB1 Output
#define	output_port27			(PORTC)
#define	output_port01			(PORTB)
#define	input_port27			(PINC)
#define	input_port01			(PINB)
#define	mask_data27				( (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) | (1 << PC6) | (1 << PC7) )
#define	mask_data01				( (1 << PB0) | (1 << PB1) )


// ******** Global Data ********
extern	unsigned int	disp_write_data_pos;					// \pݎMf[^|WV
extern	unsigned int	read_data_pos;							// ǂݏoMf[^JE^[
extern	unsigned int	disp_end_pos;
extern	unsigned char	disp_hex;								// 1:PUi\
extern	unsigned char	disp_moji[21];							// kbc\
extern	unsigned char	n_of_disp_data;							// kbc\鐔̍ő吔iPU͂Sj
extern	unsigned char	n_of_one_line_disp_data;				// Psɕ\f[^
extern	unsigned char	n_of_line;								// kbc\s
extern	unsigned char	n_of_disp_data_pass;					// oߎԗL̂kbc\鐔̍ő吔
extern	unsigned char	n_of_one_line_disp_data_pass;			// oߎԗL̂Psɕ\f[^
extern	unsigned char	set_back_light;							// obNCgnm^nee


// ******* Global Function ******
extern	void			disp_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);
extern	void			disp_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);
extern	void			disp_clear_lcd_G(void);
extern	void			init_lcd_G(void);
extern	void			disp_direction_signe_lcd_G(void);
extern	void			back_light(unsigned char lon);
extern	void			disp_one_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc);
extern	void			disp_one_char_lcd_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char uc);
extern	void			lcd_G_cmd_out(unsigned char cs, unsigned char uc);
extern	void			lcd_G_data_out(unsigned char cs, unsigned char uc);
extern	unsigned char	lcd_G_data_in(void);
extern	void			disp_one_10x16_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc);
extern	void			disp_lcd_10x16_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);


// ****** Define ******
#define		TIM_BACK_LIGHT_ON	10								// obNCg_ԁibj

// ******* Global Function for Check ******
extern	void	disp_lcd_G_font_check1(void);
extern	void	disp_lcd_G_font_check2(void);
