//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Serial.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include			<avr/io.h>
#include			<avr/eeprom.h>


#include			"AVR_ATmega644_Geiger.h"
#include			"Serial.h"
#include			"Timer.h"
#include			"Ad_conv.h"
#include			"Utility.h"
#include			"LCD.h"
#include			"Comm1.h"
#include			"EEPROM.h"
#include			"Seeprom.h"
#include			"Rtc.h"

#include			"Setting.h"

unsigned int		v_ubrr[CODE_BPS_MAX+1] ={			// BPS ɑ΂ enum code_bps Ɠт̕KvL
						BPS_1200,						// taqqO̒l(1200)
						BPS_2400,						// taqqO̒l(2400)
						BPS_4800,						// taqqO̒l(4800)
						BPS_9600,						// taqqO̒l(9600)
						BPS_14400,						// taqqO̒l(14400)
						BPS_19200,						// taqqO̒l(19200)
						BPS_28800,						// taqqO̒l(28800)
						BPS_38400,						// taqqO̒l(38400)
						BPS_57600,						// taqqO̒l(57600)
						BPS_76800,						// taqqO̒l(76800)
						BPS_115200,						// taqqO̒l(115200)
					};

unsigned char		set_bps = CODE_9600;				// ݂̐ݒaorR[h̒l
unsigned char		set_parity = CODE_PARITY_NON;		// ݂̐ݒpeBR[h̒l
unsigned char		set_data_length = CODE_DATA_8;		// ݂̃f[^R[h̒l
unsigned char		set_end_less = CODE_END_LESS;		// OFGhXAPFGhXłȂif[^obt@tɂȂ~j
unsigned char		set_pass_time = CODE_PASS_TIME_OFF;	// OFoߎԖAPFoߎԗL
unsigned char		trig_data;							// X^[ggK@̓GhgḰ@f[^

unsigned char		save_set_bps;						// Mf[^̐ݒaorR[h̒l
unsigned char		save_set_parity;					// Mf[^̐ݒpeBR[h̒l
unsigned char		save_set_data_length;				// Mf[^̃f[^R[h̒l
unsigned char		save_set_end_less;					// Mf[^́@OFGhXAPFGhXłȂif[^obt@tɂȂ~j
unsigned char		save_set_pass_time;					// Mf[^̌oߎԂ̗L@OFoߎԖAPFoߎԗL
unsigned char		save_trig_data;						// Mf[^̃X^[ggK@̓GhgḰ@f[^

unsigned int		rxd_err_data[N_of_RXD];				// D8--D15:G[Ԏ擾AD0--D7:Mf[^擾
unsigned int		write_data_pos;						// ݎMf[^|WV
unsigned char		data_get_run;						// Mf[^擾
unsigned char		rxd_rec;							// qwO͂qwPM
unsigned int		n_of_receive;						// 擾Mf[^
signed int			n_of_valid_receive;					// LMf[^
unsigned char		old_data_get_run;					// Mf[^擾IɂȌԁi擾̑j
unsigned int		first_pos_num;						// ō̎Mf[^ԍiP`mQQqwcj
unsigned int		n_of_valid_rxd;


//*****************************************
// ^CgAo[WM
//*****************************************
void	tx_title(void)
{
	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	uart0_tx_str_crlf("");										// UART TxD String + CR + LF
	tx0_str(&disp_moji[0]);										// UART TxD String

	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	uart0_tx_str_crlf((char *)&disp_moji[0]);					// UART TxD String + CR + LF

#ifdef		ONE_BATTERY
	get_pgm_str(&str_title_3[0]);								// vÖ̕ P{obe[擾
	tx0_char(' ');
	uart0_tx_str_crlf((char *)&disp_moji[0]);					// UART TxD String + CR + LF
#endif

}
//*****************************************
// vO쐬NM
//*****************************************
void	tx_make_data(void)
{
	get_pgm_str(&str_make_date[0]);								// vÖ̕("Make Date:")擾
	tx0_str(&disp_moji[0]);										// UART TxD String

	tx0_char(' ');
	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	tx0_str(&disp_moji[0]);										// UART TxD String

	tx0_char(' ');
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	uart0_tx_str_crlf((char *)&disp_moji[0]);					// UART TxD String + CR + LF

}
//*****************************************
// ݒWM
//*****************************************
void	tx_setting_value(void)
{
	// HV Moni
	get_pgm_str(&str_hv_moni[0]);								// vÖ̕("HV Moni")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(' ');
	get_pgm_str(&str_span[0]);									// vÖ̕("Span")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,hv_hosei_spn);					// Xp␳ Data
	tx0_str(&disp_moji[1]);										// UART TxD String
	tx0_char(',');
	tx0_char(' ');
	get_pgm_str(&str_offset[0]);								// vÖ̕("Offset")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,hv_hosei_ofs);					// ItZbg␳ Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

	// HV Volt
	get_pgm_str(&str_hv_volt[0]);								// vÖ̕("HV-VOLT")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji, hv_target_volt);					// ␳ Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

	// cpm->uSv/h Span
	get_pgm_str(&str_cpm_to_uSv[0]);							// vÖ̕("cpm->uSv")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(' ');
	get_pgm_str(&str_span[0]);									// vÖ̕("Span")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = '.';
	tx0_str(&disp_moji[1]);										// UART TxD String
	tx0_char(',');
	tx0_char(' ');
	get_pgm_str(&str_offset[0]);								// vÖ̕("Offset")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

}

//*****************************************
// ۑf[^iPԖ͂PԂƁj̑M
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	transmit_cph_save_data(unsigned char cph)
{
	unsigned int	i;
	unsigned char	uc;
	unsigned long	ul;
	unsigned int	ui;
	unsigned char	saidai;

	tx_title();									// ^CgAo[WM
	tx_make_data();								// vO쐬NM
	tx_setting_value();							// ݒWM
	disp_clear_lcd_G();								// Clear Display
	get_pgm_str(&str_save_data_transmit[0]);		// "Transmit Save Data"
	disp_lcd_G(1,0,disp_moji);						// \
	tx0_str(&disp_moji[0]);							// UART TxD String
	if(cph == 0){									// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else if(cph == 1){								// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else{											// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}
	tx0_char(' ');
	uart0_tx_str_crlf((char *)&disp_moji[0]);		// UART TxD String + CR + LF

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	eeprom_busy_wait();
	if(cph == 0){									// PԂƃf[^(cpm)̎
		uc = eeprom_read_byte(&eep_cpm_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_MINUTE_DATA;
	}else if(cph == 1){								// PԖf[^̎
		uc = eeprom_read_byte(&eep_cph_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_HOUR_DATA;
	}else{											// Pf[^̎
		uc = eeprom_read_byte(&eep_cpd_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_DAY_DATA;
	}
	if(uc == 0xff){									// ۑ
		get_pgm_str(&str_no_data[0]);				// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);					// \
		uart0_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
	
		delay_ms(4000);								// 4000mS Delay

	}else{											// ۑL鎞
		i = 1;
		for(;;){
			if(i == 0){
				get_pgm_str(&str_done[0]);												// vÖ̕("Done")擾
				disp_lcd_G( 8,5,disp_moji);												// \
				delay_ms(2000);															// 2000mS Delay
				break;
			}else{
				for(; ; ){
					uc--;
					if(saidai <= uc){
						uc = (saidai - 1);
					}

					tx0_char('-');
					wtod_05u((char *)(&disp_moji[0]), i);								// ԍ
					tx0_str(&disp_moji[0]);												// UART TxD String
					tx0_char(':');

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = eeprom_read_dword(eep_minute_time_data + uc);				// PԖf[^̎ǂݏo
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_time_data + uc);				// PԖf[^̎ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_time_data + uc);					// Pf[^̎ǂݏo
					}
					convert_display_date_time(ul);										// unsigned long ̒l\pɕϊ
					tx0_str(&disp_moji[0]);												// UART TxD String
					tx0_char(',');

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = (unsigned long)eeprom_read_word(eep_minute_data + uc);		// PԖf[^̓ǂݏo
						if(ul == 0xffff){
							ul = 0xffffffff;
						}
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_data + uc);						// PԖf[^̓ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_data + uc);						// Pf[^̓ǂݏo
					}
					if(ul == 0xffffffff){
						get_pgm_str(&str_5minus[0]);									// "-----"
						tx0_str(&disp_moji[0]);											// UART TxD String
						tx0_str(&disp_moji[3]);											// UART TxD String
						tx0_char(',');
						uart0_tx_str_crlf((char *)&disp_moji[1]);						// UART TxD String + CR + LF
						i = 0;
						break;
					}else{
						ui = (unsigned short)(ul/10000);
						wtod_7u((char *)disp_moji, ul);									// PԖ͂PԂƂ̃JEg
						tx0_str(&disp_moji[0]);											// UART TxD String
						tx0_char(',');
						if(cph == 0){													// PԂƃf[^(cpm)̎
							get_uSv_at_count(ul, 1);									// rZiPԂ̃JEgɂj
						}else if(cph == 2){
							get_uSv_at_count(ul/(unsigned long)24, 0);					// rZiPԂ̃JEgɂj
						}else{
							get_uSv_at_count(ul, 0);									// rZiPԂ̃JEgɂj
						}
						uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
					}
					i++;
					if(saidai < i){
						i = 0;
						break;
					}
				}
			}
		}
	}
}
