//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Serial.h
//  wb_[t@C
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************

//#define	UART_BAISOKU	1										// t`qs̃{[[gpNbN{ݒɂ

#if		CPU_CLOCK == 20								// 20MHz
  // Xtal:20MHz
  #define	CLOCK			200000000				// NbN:20MHziPO{̒lj
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
    // Xtal:18.432MHz
    #define	CLOCK			184320000				// NbN:18.432MHziPO{̒lj
  #else
    #if	CPU_CLOCK == 16								// 16MHz
	  // Xtal:16MHz
	  #define	CLOCK		160000000				// NbN:16MHziPO{̒lj
    #else
	    // Xtal:8MHz								// 8MHz
	    #define	CLOCK		80000000				// NbN:8MHziPO{̒lj
    #endif
  #endif
#endif

#define	BIT_RATE1200		1200								// rbg|g:1200
#define	BIT_RATE2400		2400								// rbg|g:2400
#define	BIT_RATE4800		4800								// rbg|g:4800
#define	BIT_RATE9600		9600								// rbg|g:9600
#define	BIT_RATE14400		14400								// rbg|g:14400
#define	BIT_RATE19200		19200								// rbg|g:19200
#define	BIT_RATE28800		28800								// rbg|g:28800
#define	BIT_RATE38400		38400								// rbg|g:38400
#define	BIT_RATE57600		57600								// rbg|g:57600
#define	BIT_RATE76800		76800								// rbg|g:76800
#define	BIT_RATE115200		115200								// rbg|g:115200

#define	N_of_RXD			128									// Mf[^obt@iQ̊KɌj
#define	DATA_POS_MASK		(N_of_RXD - 1)

enum code_bps {													// aor
		CODE_1200=0,											// BPS_1200̏ꏊ
		CODE_2400,												// BPS_2400̏ꏊ
		CODE_4800,												// BPS_4800̏ꏊ
		CODE_9600,												// BPS_9600̏ꏊ
		CODE_14400,												// BPS_14400̏ꏊ
		CODE_19200,												// BPS_19200̏ꏊ
		CODE_28800,												// BPS_28800̏ꏊ
		CODE_38400,												// BPS_38400̏ꏊ
		CODE_57600,												// BPS_57600̏ꏊ
		CODE_76800,												// BPS_76800̏ꏊ
		CODE_115200,											// BPS_115200̏ꏊ

		CODE_BPS_MAX											// BPS ͈͊O
	};
enum code_parity {												// peB
		CODE_PARITY_NON = 0,									// peB̏ꏊ
		CODE_PARITY_EVN,										// eB̏ꏊ
		CODE_PARITY_ODD,										// peB̏ꏊ

		CODE_PARITY_MAX											// peB͈͊O
	};
enum code_data_length {											// f[^
		CODE_DATA_8 = 0,										// Wrbgf[^̏ꏊ
		CODE_DATA_7,											// Vrbgf[^̏ꏊ

		CODE_DATA_MAX											// f[^ ͈͊O
	};
enum code_end_less {											// GhX@M
		CODE_END_LESS = 0,										// GhX
		CODE_ONE_CYCL,											// f[^tɂȂI
		CODE_ERR_END,											// G[ŏI
		CODE_STR_TRIG,											// gKf[^ŃX^[g
		CODE_END_TRIG,											// gKf[^ŏI
		CODE_TRIG_CYCL,											// gKf[^ŃX^[gAf[^tŏI

		CODE_END_MAX											// Gh ͈͊O
	};
enum code_pass_time {											// oߎԁ@L
		CODE_PASS_TIME_OFF = 0,									// oߎԁ@
		CODE_PASS_TIME_ON,										// oߎԁ@L

		CODE_PASS_MAX											// oߎ ͈͊O
	};

enum code_data_get {											// Mf[^擾
		CODE_DATA_GET_END = 0,									// 擾I
		CODE_DATA_GET_RUN,										// 擾
		CODE_DATA_GET_WAIT,										// gKf[^҂

		CODE_DATA_GET_MAX										// 擾 ͈͊O
	};



// t`qs̐ݒl

#ifdef	UART_BAISOKU											// t`qs̃{[[gpNbN{ݒɂ
// aori{j
#define	BPS_1200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE1200)+5)/10 - 1 )		// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE2400)+5)/10 - 1 )		// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE4800)+5)/10 - 1 )		// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE9600)+5)/10 - 1)		// taqqO̒l(9600)
#define	BPS_14400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE14400)+5)/10 - 1)		// taqqO̒l(14400)
#define	BPS_19200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE19200)+5)/10 - 1)		// taqqO̒l(19200)
#define	BPS_28800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE28800)+5)/10 - 1)		// taqqO̒l(28800)
#define	BPS_38400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE38400)+5)/10 - 1)		// taqqO̒l(38400)
#define	BPS_57600		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE57600)+5)/10 - 1)		// taqqO̒l(57600)
#define	BPS_76800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE76800)+5)/10 - 1)		// taqqO̒l(76800)
#define	BPS_115200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE115200)+5)/10 - 1)		// taqqO̒l(115200)

#else

// aor
#define	BPS_1200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE1200)+5)/10 - 1 )		// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE2400)+5)/10 - 1 )		// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE4800)+5)/10 - 1 )		// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE9600)+5)/10 - 1)		// taqqO̒l(9600)
#define	BPS_14400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE14400)+5)/10 - 1)		// taqqO̒l(14400)
#define	BPS_19200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE19200)+5)/10 - 1)		// taqqO̒l(19200)
#define	BPS_28800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE28800)+5)/10 - 1)		// taqqO̒l(28800)
#define	BPS_38400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE38400)+5)/10 - 1)		// taqqO̒l(38400)
#define	BPS_57600		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE57600)+5)/10 - 1)		// taqqO̒l(57600)
#define	BPS_76800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE76800)+5)/10 - 1)		// taqqO̒l(76800)
#define	BPS_115200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE115200)+5)/10 - 1)		// taqqO̒l(115200)
#endif

extern	unsigned int	v_ubrr[CODE_BPS_MAX+1];					// BPS ɑ΂ enum code_bps Ɠт̕KvL


extern	unsigned char		set_bps;							// ݂̐ݒaorR[h̒l
extern	unsigned char		set_parity;							// ݂̐ݒpeBR[h̒l
extern	unsigned char		set_data_length;					// ݂̃f[^R[h̒l
extern	unsigned char		set_end_less;						// OFGhXAPFGhXłȂif[^obt@tɂȂ~j
extern	unsigned char		set_pass_time;						// OFoߎԖAPFoߎԗL
extern	unsigned char		trig_data;							// X^[ggK@̓GhgḰ@f[^
extern	unsigned char		save_set_bps;						// Mf[^̐ݒaorR[h̒l
extern	unsigned char		save_set_parity;					// Mf[^̐ݒpeBR[h̒l
extern	unsigned char		save_set_data_length;				// Mf[^̃f[^R[h̒l
extern	unsigned char		save_set_end_less;					// Mf[^́@OFGhXAPFGhXłȂif[^obt@tɂȂ~j
extern	unsigned char		save_set_pass_time;					// Mf[^̌oߎԂ̗L@OFoߎԖAPFoߎԗL
extern	unsigned char		save_trig_data;						// Mf[^̃X^[ggK@̓GhgḰ@f[^

extern	unsigned int		rxd_err_data[N_of_RXD];				// D8--D15:G[Ԏ擾AD0--D7:Mf[^擾
extern	unsigned int		write_data_pos;						// ݎMf[^|WV
extern	unsigned char		data_get_run;						// Mf[^擾
extern	unsigned char		rxd_rec;							// qwO͂qwPM
extern	unsigned int		n_of_receive;						// 擾Mf[^
extern	signed int			n_of_valid_receive;					// LMf[^
extern	unsigned char		old_data_get_run;					// Mf[^擾IɂȌԁi擾̑j
extern	unsigned int		first_pos_num;						// ō̎Mf[^ԍiP`mQQqwcj
extern	unsigned int		n_of_valid_rxd;

extern	void	tx_title(void);									// ^CgAo[WM
extern	void	tx_make_data(void);								// vO쐬NM
extern	void	tx_setting_value(void);							// ݒWM
extern	void	transmit_cph_save_data(unsigned char cph);		// ۑf[^iPԖ͂PԂƁj̑M
