//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Utility.h
//  wb_[t@C
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************

// XCb`
//  PD6: Tact Switch(Yellow)
//  PD7: Tact Switch(White)
#define	SW_LEFT		(1 << PIND6)
#define	SW_RIGHT	(1 << PIND7)

#ifdef		PD5_DEBUG_OUT
#else		//PD5_DEBUG_OUT
//  PD5: Tact Switch(Spear)
#define	SW_SPEAR	(1 << PIND5)
#endif		//PD5_DEBUG_OUT

extern	unsigned char			sw[3];

// kdc
//  PB3: RED LED(H=ON, L=OFF)
#define	led_init()	DDRB |= (1 << DDB3)					// Port-B Bit3 : Output
#define	led_on()	PORTB |=  (1 << PB3)				// LED ON
#define	led_off()	PORTB &= ~(1 << PB3)				// LED OFF


// Debug Signal
#ifdef		PD5_DEBUG_OUT
#define	DEBUG_sig_init()	DDRD |= (1 << DDD5)					// Port-D Bit5 : Output
#define	DEBUG_sig_on()		PORTD |= (1 << DDD5)
#define	DEBUG_sig_off()		PORTD &= ~(1 << DDD5)
#else		//PD5_DEBUG_OUT
#define	DEBUG_sig_init()
#define	DEBUG_sig_on()
#define	DEBUG_sig_off()
#endif		//PD5_DEBUG_OUT

extern	void	wtod_02x(char *bf,unsigned char ucd);
extern	void	wtod_02u(char *bf,unsigned char ucd);
extern	void	wtod_2u(char *bf,unsigned char ucd);
extern	void	wtod_05u(char *bf,unsigned int usd);
extern	void	wtod_5u(char *bf,unsigned int usd);
extern	void	wtod_07u(char *bf,unsigned long uld);
extern	void	wtod_7u(char *bf,unsigned long uld);
extern	void	wtod_l7u(char *bf,unsigned long uld);
extern	void	wtod_010u(char *bf,unsigned long uld);
extern	void	wtod_10u(char *bf,unsigned long uld);

extern	void	wtod_04x(char *bf,unsigned int ucd);
extern	void	wtod_03u(char *bf,unsigned int ucd);
extern	void	llstrncpy(char *b1,char *b2,short n);
extern	void	llstrcpy(char *b1,char *b2);
extern	void	get_sw(void);
extern	void	sw_init(void);
extern	void	get_pgm_str(unsigned char *puc);
